Attribute VB_Name = "ModMain"
'**********************************************
'              Z X T O K E N
'**********************************************
'
'  *****  *   *
'     *    * *
'    *      *
'   *      * *
'  *****  *   *  Tools           -= XavSnap =-
'
'http://dskcenter.free.fr/zxtools.html
'**********************************************
'

Option Explicit ' Declare all variables. (to avoid redundant public/private declaration)

Public Computer As String ' ="ZX81" or ="SPECTRUM"
Public GRAPHIC_MODE As Boolean
Public CBI_SW As Boolean
Public hFile As Integer ' File handel
Public CurLine As String
Public CurNBLn As Long
Public FncString As String * 6
Public ZXbuffer() As Byte
Public Cmp_Decay As Long
Public ZxOffset As Long
Public LastLine As Long
Public FrtLine As Integer
Public ErrIndex As Long
Public InputLine As Long

Public Lines() As Long
Public lineCtr As Long
Public Prog_ZX() As Byte 'Zx program array.

Public NewWord As Boolean
Public Prt_Trg As Boolean
Public bNum As Boolean
Public bREM As Boolean
Public bSave As Boolean
Public Cmp As Long

' ZX81 floating point number.
Type Zx81_Long
        Exp As Integer ' - Exponent
        man As String ' - Mantissa
End Type

' Declare Unsigned integer allow to use and write an interger to &hFFFF
' Interger declaration allow a value to 32767 (&h7FFF) without the Bit15
' Used to set a positive or a negative value.
Type Uinteger
        L As Byte '&H00FF
        H As Byte '&HFF00
End Type

Type P_header '   Tape ".p" Header (size 116)
    VERSION As Byte ' Version
    E_PPC As Uinteger
    D_FILE As Uinteger ' Basic program lengh = D_File-16509
    DF_CC As Uinteger
    VARS As Uinteger ' Sart of vars Address.
    DEST As Uinteger
    E_Line As Uinteger ' Start of Basic program.
    CH_ADD As Uinteger
    X_PTR As Uinteger
    STKBOT As Uinteger
    STKEND As Uinteger
    BERG As Byte
    MEM As Uinteger
    UnByte As Byte
    DF_SZ As Byte
    S_TOP As Uinteger
    LAST_K As Uinteger
    DEBOUNCE As Byte
    MARGIN As Byte
    NXT_LINE As Uinteger
    OLDPPC As Uinteger
    FLAGX As Byte
    STRLEN As Uinteger
    T_ADDR As Uinteger
    SEED As Uinteger
    FRAMES As Uinteger
    COORDS As Uinteger
    PR_CC As Byte
    S_POSN As Uinteger
    CDFLAG As Byte
    PRBUFFER As String * 32
    PRBUFEND As Byte
    MEMBOT As String * 30
    UnWord As Uinteger
End Type

Type O_header '   Tape ".O" Header (size 40)

' 4000 : ERR.NB
' 4001 : FLAGS
' 4002 : PPC
' 4004 : E.ADDR
' 4006 : E.PPC
' 4008 : VARS
' 400A : E.LINE
' 400C : D.FILE
' 400E : DF.EA
' 4010 : DF.END
' 4012 : DF.SZ
' 4013 : S.TOP
' 4015 : X.PTR
' 4017 : OLDPPC
' 4019 : FLAGX
' 401A : T.ADDR
' 401C : SEED
' 401E : FRAMES
' 4020 : V.ADDR
' 4022 : Acc
' 4024 : S.Posn
' 4026 : Ch.Add


'00:
    SYS1 As Uinteger ' 88FFh
    SYS2 As Uinteger ' FFFEh
'04:
    SYS_VARPTR As Integer ' EOF+2 = SYS5
'06:
    Cur_Line As Integer ' Current Line Location.
'08:
    SYS_EOF As Integer ' EOF 80h location
    SYS4 As Integer ' EOF 80h location+1
    SYS5 As Integer ' EOF 80h location+3
    SYS6 As Integer ' EOF 80h location+4
    SYS7 As Integer ' EOF 80h location+5
    SYS8 As Integer ' EOF 80h location+5
    SYS9 As Integer ' 0002h
    Null1 As Integer ' 0000h
    Null2 As Integer ' 0000h
    SYS10 As Integer ' 07B0h
    Null3 As Integer ' 0000h
    Null4 As Integer ' 0000h
    Null5 As Integer ' 0000h
    Null6 As Integer ' 0000h
    SYS11 As Integer ' 1721h
    SYS12 As Integer ' EOF 80h location+2 = SYS5
End Type


Type Tap_Header ' 24 bytes
    vers As Integer
    Unk0 As Integer
    Name As String * 10
    Size1 As Integer
    StartLine As Integer
    Size2 As Integer
    Unk1 As Integer
    Unk2 As Integer
End Type

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
' VB App_Path leek
Public Declare Function GetShortPathNameA Lib "kernel32.dll" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Public Declare Function GetLongPathNameA Lib "kernel32.dll" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long


Sub Main()

' Init Vars
FrtLine = -1
InputLine = 0
ZxOffset = 0 ' Reset ZxBuffer Start AT 0
bREM = False
bSave = False
CurLine = ""
FrmMain.Show
End Sub

Sub DecodeLine()
Dim LOffset As Long
Dim TmpStr As String
LOffset = 1

CurLine = Remove_tabs(CurLine)

Do
 Do While Left(CurLine, 1) = " "
          CurLine = Right(CurLine, Len(CurLine) - 1)
 Loop

If InStr(1, CurLine, " ") = 0 Then
TmpStr = CurLine
Else
TmpStr = Left(CurLine, InStr(1, CurLine, " ") - 1)
End If

If TmpStr = "" Then LOffset = LOffset - 1: GoTo Continue

If LOffset = 1 Then
    If Left(Trim(TmpStr), 1) = "#" Then Exit Sub

    If Asc(Left(TmpStr, 1)) < &H2F Or Asc(Left(TmpStr, 1)) > &H3A Then Disp_Err 8
    CurNBLn = Val(TmpStr)
    If FrtLine < 0 Then FrtLine = CurNBLn
    End If

Continue:

CurLine = Right(CurLine, Len(CurLine) - InStr(1, CurLine, " "))

If Left(CurLine, 1) = " " Then GoTo Continue

'Zx81
If FrmMain.Computers.ListIndex = 0 Then
If LOffset = 1 Then
LastLine = ZxOffset
ZxOffset = ZxOffset + 4
NewWord = True
Conv_SPGr (CurLine)
Debug.Print "Line : "; CurLine
End If
End If

'Zx80
If FrmMain.Computers.ListIndex = 1 Then
If LOffset = 1 Then
LastLine = ZxOffset
ZxOffset = ZxOffset + 2
NewWord = True
Conv_SPGr (CurLine)
Debug.Print "Line : "; CurLine
End If
End If

LOffset = LOffset + 1
Loop Until InStr(1, CurLine, " ") = 0
End Sub

Function GetFunc(txt As String) As Long
Dim txt2 As String

GetFunc = -1
Cmp_Decay = 1

txt2 = LCase(Left(txt, 2))
If txt2 = "<>" Or txt2 = ">=" Or txt2 = "<=" Or txt2 = "**" Or bREM Then NewWord = True
txt2 = LCase(Left(txt, 1))
If txt2 = Chr(192) Then Exit Function
If Not (IsZXLetter(ASCIICharToZX(txt2))) Or txt2 = Chr(20) Then NewWord = True
If NewWord = False Then Exit Function

Cmp_Decay = 6

txt = LCase(Left(txt, 6))

'6 characters.
Select Case txt
   Case "inkey$"
       GetFunc = 65
       Exit Function
   Case "return"
       GetFunc = 254
       Exit Function
   Case "unplot"
       GetFunc = 252
       Exit Function
   Case "scroll"
       GetFunc = 231
       Exit Function
   Case "lprint"
       GetFunc = 225
       Exit Function
End Select

Cmp_Decay = 5
txt = LCase(Left(txt, 5))

'5 characters.
Select Case txt
   Case "llist"
       GetFunc = 226
       Exit Function
   Case "clear"
       GetFunc = 253
       Exit Function
   Case "print"
       GetFunc = 245
       Exit Function
   Case "pause"
       GetFunc = 242
       Exit Function
   Case "input"
       GetFunc = 238
       Exit Function
   Case "gosub"
       GetFunc = 237
       Exit Function
End Select

Cmp_Decay = 4
txt = LCase(Left(txt, 4))

'4 characters.
Select Case txt
   Case "copy"
       GetFunc = 255
       Exit Function
   Case "rand"
       GetFunc = 249
       Exit Function
   Case "save"
       GetFunc = 248
       Exit Function
   Case "plot"
       GetFunc = 246
       Exit Function
   Case "poke"
       GetFunc = 244
       Exit Function
   Case "next"
       GetFunc = 243
       Exit Function
   Case "list"
       GetFunc = 240
       Exit Function
   Case "load"
       GetFunc = 239
       Exit Function
   Case "goto"
       GetFunc = 236
       Exit Function
   Case "cont"
       GetFunc = 232
       Exit Function
   Case "fast"
       GetFunc = 229
       Exit Function
   Case "slow"
       GetFunc = 228
       Exit Function
   Case "stop"
       GetFunc = 227
       Exit Function
   Case "step"
       GetFunc = 224
       Exit Function
   Case "then"
       GetFunc = 222
       Exit Function
   Case "chr$"
       GetFunc = 214
       Exit Function
   Case "str$"
       GetFunc = 213
       Exit Function
   Case "peek"
       GetFunc = 211
       Exit Function
   Case "code"
       GetFunc = 196
       Exit Function
End Select

Cmp_Decay = 3
txt = LCase(Left(txt, 3))

'3 characters.
Select Case txt
   Case "cls"
       GetFunc = 251
       Exit Function
   Case "run"
       GetFunc = 247
       Exit Function
   Case "let"
       GetFunc = 241
       Exit Function
   Case "for"
       GetFunc = 235
       Exit Function
   Case "rem"
       GetFunc = 234
       Exit Function
   Case "dim"
       GetFunc = 233
       Exit Function
   Case "new"
       GetFunc = 230
       Exit Function
   Case "not"
       GetFunc = 215
       Exit Function
   Case "usr"
       GetFunc = 212
       Exit Function
   Case "abs"
       GetFunc = 210
       Exit Function
   Case "sgn"
       GetFunc = 209
       Exit Function
   Case "sqr"
       GetFunc = 208
       Exit Function
   Case "int"
       GetFunc = 207
       Exit Function
   Case "exp"
       GetFunc = 206
       Exit Function
   Case "atn"
       GetFunc = 204
       Exit Function
   Case "acs"
       GetFunc = 203
       Exit Function
   Case "asn"
       GetFunc = 202
       Exit Function
   Case "tan"
       GetFunc = 201
       Exit Function
   Case "cos"
       GetFunc = 200
       Exit Function
   Case "sin"
       GetFunc = 199
       Exit Function
   Case "len"
       GetFunc = 198
       Exit Function
   Case "val"
       GetFunc = 197
       Exit Function
   Case "tab"
       GetFunc = 194
       Exit Function
   Case "and"
       GetFunc = 218
       Exit Function
   Case "rnd"
       GetFunc = 64
       Exit Function

End Select

Cmp_Decay = 2
txt = LCase(Left(txt, 2))

'2 characters.
Select Case txt
   Case "if"
       GetFunc = 250
       Exit Function
   Case "to"
       GetFunc = 223
       Exit Function
  Case "<>"
       GetFunc = 221
       Exit Function
   Case ">="
       GetFunc = 220
       Exit Function
   Case "<="
       GetFunc = 219
       Exit Function
   Case "><"
       GetFunc = 221
       Exit Function
   Case "=>"
       GetFunc = 220
       Exit Function
   Case "=<"
       GetFunc = 219
       Exit Function
   Case "or"
       GetFunc = 217
       Exit Function
   Case "**"
       GetFunc = 216
       Exit Function
   Case "ln"
       GetFunc = 205
       Exit Function
   Case "at"
       GetFunc = 193
       Exit Function
   Case "pi"
       GetFunc = 66
       Exit Function
   Case Chr(34) + Chr(34)
       GetFunc = 192
       Exit Function
End Select
Cmp_Decay = 1
txt = Left(txt, 1)
If txt = Chr(20) Then NewWord = True Else NewWord = False
End Function

Sub Conv_SPGr(Text As String)


Dim car_tmp As String * 1
Dim GrStr As String * 2
Dim RetByte As Byte
Dim Result As Long

Dim TMPNum As String

Dim Get_V As Byte

Prt_Trg = False
TMPNum = ""
bNum = False
NewWord = True

Do While Text <> ""

  car_tmp = Left(Text, 1)
  
  If car_tmp = " " And Not (Prt_Trg Or bREM) Then
       NewWord = True
  End If

Select Case car_tmp

Case "\"
  Dim DecOff As Integer
  DecOff = 3
  GrStr = Mid(Text, 2, 2)
  
'Zx81 ZXText2P chars codes. (Chris Cowley)
If FrmMain.Computers.ListIndex = 0 Then
  Select Case GrStr
    Case Chr(&H22) + Chr(&H22)
    RetByte = &HC0
    Case "  "
    RetByte = &H0
    Case "' "
    RetByte = &H1
    Case " '"
    RetByte = &H2
    Case "''"
    RetByte = &H3
    Case ". "
    RetByte = &H4
    Case ": "
    RetByte = &H5
    Case ".'"
    RetByte = &H6
    Case ":'"
    RetByte = &H7
    Case "##"
    RetByte = &H8
    Case ",,"
    RetByte = &H9
    Case "~~"
    RetByte = &HA
    Case "::"
    RetByte = &H80
    Case ".:"
    RetByte = &H81
    Case ":."
    RetByte = &H82
    Case ".."
    RetByte = &H83
    Case "':"
    RetByte = &H84
    Case " :"
    RetByte = &H85
    Case "'."
    RetByte = &H86
    Case " ."
    RetByte = &H87
    Case "@@"
    RetByte = &H88
    Case ";;"
    RetByte = &H89
    Case "!!"
    RetByte = &H8A
    Case Else
    
        If Left(GrStr, 1) = Chr(&H22) Then
         RetByte = &HC0: DecOff = 2
        Else
          Disp_Err 3
          RetByte = 143
        End If
    End Select
 End If
 
 'Zx80 based on ZXText2P's chars codes.
 If FrmMain.Computers.ListIndex = 1 Then
   Select Case GrStr
    Case "  "
    RetByte = &H0
    Case "' "
    RetByte = &H4
    Case " '"
    RetByte = &H5
    Case "''"
    RetByte = &H83
    Case ". "
    RetByte = &H6
    Case ": "
    RetByte = &H2
    Case ".'"
    RetByte = &H8
    Case ":'"
    RetByte = &H87
    Case "##"
    RetByte = &H9
    Case ",,"
    RetByte = &HA
    Case "~~"
    RetByte = &HB
    Case "::"
    RetByte = &H80
    Case ".:"
    RetByte = &H84
    Case ":."
    RetByte = &H85
    Case ".."
    RetByte = &H3
    Case "':"
    RetByte = &H86
    Case " :"
    RetByte = &H82
    Case "'."
    RetByte = &H88
    Case " ."
    RetByte = &H7
    Case "@@"
    RetByte = &H89
    Case ";;"
    RetByte = &H8A
    Case "!!"
    RetByte = &H8B
    Case Else

          Disp_Err 3
          RetByte = 143

    End Select
 End If
    
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = RetByte
    ZxOffset = ZxOffset + 1
    Text = Right(Text, Len(Text) - DecOff)


Case "%"
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = 143
    On Error Resume Next
    If Asc(Mid(Text, 2, 1)) = &H16 Then
       ZXbuffer(ZxOffset) = 128
        Else
    
        Select Case FrmMain.Computers.ListIndex
            Case 0
             ZXbuffer(ZxOffset) = CByte(ASCIICharToZX(UCase(Mid(Text, 2, 1)))) + 128
            Case 1
            
    ' ZX80 Char codes.
    Select Case Mid(Text, 2, 1)
    Case "("
        ZXbuffer(ZxOffset) = 144
        
    Case ")"
        ZXbuffer(ZxOffset) = 145
        
    Case ">"
        ZXbuffer(ZxOffset) = 151
        
    Case "<"
        ZXbuffer(ZxOffset) = 152
        
    Case "="
        ZXbuffer(ZxOffset) = 150
        
    Case "+"
        ZXbuffer(ZxOffset) = 147
        
    Case "-"
        ZXbuffer(ZxOffset) = 146
        
    Case "*"
        ZXbuffer(ZxOffset) = 148
        
    Case "/"
        ZXbuffer(ZxOffset) = 149
        
    Case ";"
        ZXbuffer(ZxOffset) = 153
        
    Case ","
        ZXbuffer(ZxOffset) = 154
        
    Case "."
        ZXbuffer(ZxOffset) = 155
        
    Case Else
        ZXbuffer(ZxOffset) = CByte(ASCIICharToZX80(UCase(Mid(Text, 2, 1)))) + 128
    End Select
    
    End Select
         
    End If
    ZxOffset = ZxOffset + 1
    Text = Right(Text, Len(Text) - 2)
    
 Case "[" 'ASM Codes!.
 
     Text = Right(Text, Len(Text) - 1)
     Text = Get_ASM(Text)
     car_tmp = ""
   
Case Else


Cmp_Decay = 1
' Retrive exponent...
If bNum And UCase(car_tmp) = "E" Then  'And car_tmp <> "-"
TMPNum = TMPNum + car_tmp
End If

If (Asc(car_tmp) > &H2F And Asc(car_tmp) < &H3A) Or car_tmp = "." Then  'Or car_tmp = "-" Then
    bNum = True: TMPNum = TMPNum + car_tmp
    Debug.Print car_tmp
Else
    
 If bNum And (UCase(car_tmp) <> "E") Then  'Or car_tmp <> "-"
   
    If Not Prt_Trg And Not bREM And FrmMain.Computers.ListIndex = 0 Then
      
       NewWord = True
      
            ' If the number is a variable indentation number A1 A2 ... Don't add the num. Tag.
            Get_V = ZXbuffer(ZxOffset - Len(TMPNum) - 1)
            
            If Get_V < 38 Or Get_V > 63 Then
                        Debug.Print ">>"; ZXCharToASCII(Get_V); TMPNum
            Add_Num TMPNum
            
            Do While Left(Text, 1) = " "
             Text = Right(Text, Len(Text) - 1)
            Loop
            Else
            Debug.Print ">"; ZXCharToASCII(Get_V); TMPNum
            End If
     TMPNum = ""
     bNum = False

    End If
   
 End If
End If

If Text = "" Then GoTo Exit_Scan

Select Case FrmMain.Computers.ListIndex
Case 0
        If (Not Prt_Trg) And (Not bREM) And Not (IsZxChar(ZxOffset - 1)) Then NewWord = True
        If bSave Then NewWord = False
        Result = GetFunc(Left(Text, 6))
        
 If Result <> 65 Then
        Dim txt2 As String
        
       '  Case of "Let PIA=0", Don't get "PI_A=0"
        If Cmp_Decay < Len(Text) Then
        txt2 = LCase(Mid(Text, Cmp_Decay + 1, 1))
     If IsZXLetter(ASCIICharToZX(LCase(Left(Text, 1)))) Then
          If NewWord And Result > 0 And (((IsZXLetter(ASCIICharToZX(txt2)))) Or txt2 = "=") Then
             Cmp_Decay = 1: Result = -1: NewWord = True
          End If
        End If
     End If
 End If
 
Case 1
        If (Not Prt_Trg) And (Not bREM) Then NewWord = True
        Result = GetFuncZX80(Left(Text, 9))
End Select

'Don't get a function in word.
If (Not Prt_Trg) And (Not bREM) And Result <> -1 Then
    If NewWord = False Then
      Cmp_Decay = 1: Result = -1
    End If
End If

'Force functions to chars in REMs
If bREM Then
    NewWord = False: Cmp_Decay = 1: Result = -1
End If


'Don't Get a [""]=chr$(192) while using INKEY$=""  ["]+["]=chr$(11)+chr$(11)
If Result = 192 Then
Select Case ZXbuffer(ZxOffset - 1)
Case 18, 19, 20, 21, 25, 26, 219, 220, 221
 Result = -1: Cmp_Decay = 1
End Select
End If

If Result = -1 Or Prt_Trg Then

    If (Not Prt_Trg) And (Not bREM) Then car_tmp = UCase(car_tmp)
    If FrmMain.bcase.Value <> 0 Then car_tmp = UCase(car_tmp)
    
    Cmp_Decay = 1
    ReDim Preserve ZXbuffer(ZxOffset)
    
    Select Case FrmMain.Computers.ListIndex
    Case 0
      ZXbuffer(ZxOffset) = ASCIICharToZX(car_tmp)
    Case 1
      ZXbuffer(ZxOffset) = ASCIICharToZX80(car_tmp)
    End Select
    
    If ZXbuffer(ZxOffset) = 11 And FrmMain.Computers.ListIndex = 0 Then Prt_Trg = Not Prt_Trg: If bNum Then TMPNum = "": bNum = False
    If ZXbuffer(ZxOffset) = 1 And FrmMain.Computers.ListIndex = 1 Then Prt_Trg = Not Prt_Trg: If bNum Then TMPNum = "": bNum = False
  
    If ZXbuffer(ZxOffset) = 22 Then
      If (ZXbuffer(ZxOffset - 7) < 28 Or ZXbuffer(ZxOffset - 7) > 37) And Not bNum Then
         
         'TMPNum = "-": bNum = True
      Else
     
     If Not bNum Then
     TMPNum = ""
     bNum = False
     End If
     
      End If
      End If
    ZxOffset = ZxOffset + 1
    
    Text = Right(Text, Len(Text) - Cmp_Decay)
    
    If Not (Prt_Trg Or bREM) Then
    Do While Left(Text, 1) = " "
      Text = Right(Text, Len(Text) - 1)
      NewWord = True
    Loop
    End If

Else
    If Result = 234 Then
    ' Result = 234 ' Rem
    ' Result = 248 ' Save
    bREM = True
    End If
    
     If Result = 248 Then
    ' Result = 234 ' Rem
    ' Result = 248 ' Save
    bREM = True
    bSave = True
    End If
   
    
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = CByte(Result)
    ZxOffset = ZxOffset + 1
    If Result <> 192 Then
        Do While Mid(Text, Cmp_Decay, 1) = " "
            Cmp_Decay = Cmp_Decay + 1
        Loop
    End If
    Text = Right(Text, Len(Text) - Cmp_Decay)
    
    If Not (Prt_Trg Or bREM) Then
        Do While Left(Text, 1) = " "
          Text = Right(Text, Len(Text) - 1)
        Loop
    End If
    
    If Result = 234 And InStr(1, Text, "[") <> 0 Then
    ' Result = 234 ' Rem
        Do While Left(Text, 1) = " "
          Text = Right(Text, Len(Text) - 1)
        Loop

    End If
    
End If
 
End Select
Loop

Exit_Scan:

    If bNum And FrmMain.Computers.ListIndex = 0 Then
    If (Not Prt_Trg) And (Not bREM) Then

            Get_V = ZXbuffer(ZxOffset - Len(TMPNum) - 1)
            If Get_V < 38 Or Get_V > 63 Then
            Add_Num TMPNum
           End If
    End If
     
    TMPNum = ""
    bNum = False
    End If

     ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = 118
    ZXbuffer(LastLine) = (CurNBLn And &HFF00) / 256
    ZXbuffer(LastLine + 1) = (CurNBLn And &HFF)
    
    If CurNBLn > 9999 Then
     Disp_Err 8
    End If
    
    If FrmMain.Computers.ListIndex = 0 Then
    ZXbuffer(LastLine + 2) = ((ZxOffset - LastLine - 3) And &HFF)
    ZXbuffer(LastLine + 3) = ((ZxOffset - LastLine - 3) And &HFF00) / 256
    End If
    
    ZxOffset = ZxOffset + 1
    
    lineCtr = lineCtr + 1
    ReDim Preserve Lines(lineCtr)
    Lines(UBound(Lines)) = CurNBLn
    
End Sub

Public Function ASCIICharToZX(ByVal cZX As String) As Byte
Debug.Print cZX
    If cZX = "" Or cZX = Chr(224) Or cZX = Chr(255) Then ASCIICharToZX = 143: Exit Function
    
' Convert PC Codes to ZX characters codes.
'  Pc Display to Zx81 Memory.
    
    Dim cZX_Asc As Byte
    cZX_Asc = Asc(cZX)
    
    Select Case cZX_Asc
    Case &H30 To &H39
        ASCIICharToZX = cZX_Asc - 20: Exit Function
        
    Case &H41 To &H5A
        ASCIICharToZX = cZX_Asc - 27: Exit Function
        
    Case &H61 To &H7A
        ASCIICharToZX = cZX_Asc + 69: Exit Function
        
    Case Asc(&HD) ' , Asc(&HA)  '"N/L" vbCrLf
        ASCIICharToZX = 118: Exit Function

    Case Asc(" ") ' // SPACE
        ASCIICharToZX = 0: Exit Function
    Case 34 To 36
        ' 11 = 34   "
        ' 12 = 35  /#
        ' 13 = 36  $
        ASCIICharToZX = cZX_Asc - 23: Exit Function
    Case Asc(":")
        ' 14 = :
        ASCIICharToZX = 14: Exit Function
    Case Asc("?")
        ' 15 = ?
        ASCIICharToZX = 15: Exit Function
    Case Asc("(")
        ' 16 = (
        ASCIICharToZX = 16: Exit Function
    Case Asc(")")
        ' 17 = )
        ASCIICharToZX = 17: Exit Function
    Case Asc(">")
        ' 18 = >
        ASCIICharToZX = 18: Exit Function
    Case Asc("<")
        ' 19 = <
        ASCIICharToZX = 19: Exit Function
    Case Asc("=")
        ' 20 = =
        ASCIICharToZX = 20: Exit Function
    Case Asc("+")
        ' 21 = +
        ASCIICharToZX = 21: Exit Function
    Case Asc("-")
        ' 22 = -
        ASCIICharToZX = 22: Exit Function
    Case Asc("*")
        ' 23 = *
        ASCIICharToZX = 23: Exit Function
    Case Asc("/")
        ' 24 = /
        ASCIICharToZX = 24: Exit Function
    Case Asc(";")
        ' 25 = ;
        ASCIICharToZX = 25: Exit Function
    Case Asc(",")
         ' 26 = ,
        ASCIICharToZX = 26: Exit Function
    Case Asc(".")
        ' 27 = .
        ASCIICharToZX = 27: Exit Function
        
        
  ' ZxDraw ASCII chars.
  
  'Invert chars
  Case &H86 To &HA0
      Debug.Print ZXCharToASCII(cZX_Asc + 5)
  ASCIICharToZX = cZX_Asc + 5: Exit Function
  
  Case &HA3
  ASCIICharToZX = 12: Exit Function
  
  '  "\" + Chr(&H22)+ Chr(&H22)
  Case &HC0
  ASCIICharToZX = 192: Exit Function
  
  '  "\' "
  Case &HB6
  ASCIICharToZX = 1: Exit Function
  
  '  "\ '"
    Case &HB7
  ASCIICharToZX = 2: Exit Function
    
  '  "\''"
   Case &HB8
  ASCIICharToZX = 3: Exit Function

  '  "\. "
  
  Case &HB9
  ASCIICharToZX = 4: Exit Function

  '  "\: "
  Case &HBA
  ASCIICharToZX = 5: Exit Function

  '  "\.'"
  Case &HBB
  ASCIICharToZX = 6: Exit Function

  '  "\:'"
  Case &HBC
  ASCIICharToZX = 7: Exit Function

  '  "\##"
  Case &HBD
  ASCIICharToZX = 8: Exit Function

  '  "\,,"
  Case &HBE
  ASCIICharToZX = 9: Exit Function

  '  "\~~"
  Case &HBF
  ASCIICharToZX = 10: Exit Function

  '  "\::"
  Case &HAB
  ASCIICharToZX = &H80: Exit Function

  '  "\.:"
  Case &HAC
  ASCIICharToZX = &H81: Exit Function

  '  "\:."
  Case &HAD, &HAA
  ASCIICharToZX = &H82: Exit Function

  '  "\.."
  Case &HAE
  ASCIICharToZX = &H83: Exit Function

  '  "\':"
  Case &HAF
  ASCIICharToZX = &H84: Exit Function
  
   '  "\ :"
  Case &HB0
  ASCIICharToZX = &H85: Exit Function

  '  "\'."
  Case &HB1
  ASCIICharToZX = &H86: Exit Function

   '  "\ ."
  Case &HB2
  ASCIICharToZX = &H87: Exit Function

   '  "\@@"
  Case &HB3
  ASCIICharToZX = &H88: Exit Function

  '  "\;;"
  Case &HB4
  ASCIICharToZX = &H89: Exit Function

  '  "\!!"
  Case &HB5
  ASCIICharToZX = &H8A: Exit Function

    Case Else
    
    ' While Ascii scan, don't bother the "[" symbol. (The next Char. scan in variables names)
      If cZX <> "[" Then Disp_Err 4
        ASCIICharToZX = 143
    End Select
End Function

Sub Init_SyS_VARS(SYSVARS As P_header)
Dim DFiles As Long

' Init P file header.
    DFiles = (ZxOffset) + &H407D ' Address of D_FILE
    
   
    ' E_PPC    - Line number of line which has the edit cursor.
    SYSVARS.E_PPC = StoUint(CLng(FrtLine))

    ' D_FILE   - Address of display file
    SYSVARS.D_FILE = StoUint(DFiles)
        
    ' DF_CC    - Address of print position in display file
    SYSVARS.DF_CC = StoUint(DFiles)
    
    If FrmMain.Diet_DF > 0 Then DFiles = DFiles + 26 Else DFiles = DFiles + 793 ' = Address of VARS area.
    
    ' VARS     - Address of program variables
    SYSVARS.VARS = StoUint(DFiles)

    ' E_LINE   - Pointer to line edit buffer
    SYSVARS.E_Line = StoUint(DFiles)
    
    ' CH_ADD   - Address of the next character to be interpreted
    SYSVARS.CH_ADD = StoUint(DFiles)
    
    ' STKBOT   - Points to the bottom of the calculator stack AND...
    SYSVARS.STKBOT = StoUint(DFiles)
    
    ' STKEND   - Points to the end of the calculator stack
    SYSVARS.STKEND = StoUint(DFiles)

    ' MEM      - Address of area used for calculator's memory (we point this at MEMBOT 0x405D */
    SYSVARS.MEM = StoUint(&H405D)
    
    ' DF_SZ       - Number of lines (including 1 blank line) in lower part of the screen */
    SYSVARS.DF_SZ = 2
    
    ' LAST_K      - Shows which keys are pressed
    SYSVARS.LAST_K = StoUint(&HFFFF)
    
    ' DEBOUNCE    - Debounce status of keyboard
    SYSVARS.DEBOUNCE = &HF
    
    ' MARGIN      - Number of scanlines before start of display (55=PAL, 31=NTSC)
    SYSVARS.MARGIN = 55
    
    ' NXTLINE  - Address of next program line to be executed
    SYSVARS.NXT_LINE = SYSVARS.E_PPC
    
    ' T_ADDR      - Address of next item in syntax table
    SYSVARS.T_ADDR = StoUint(&HC6B)
    
    ' FRAMES      - Seed for random number generation. Set by RAND
    SYSVARS.FRAMES = StoUint(&HFD7D)
    
    ' PR_CC       - Least significant byte of address of next position for LPRINT to print
    SYSVARS.PR_CC = &HBC
    
    ' S_POSN x    - Column number for print position
    ' S_POSN y    - Row number for print position
    SYSVARS.S_POSN = StoUint(&H1821)
    
    ' CDFLAG      - Various flags. Bit 7 is set during SLOW mode, Bit 6 is the true fast/slow flag
    SYSVARS.CDFLAG = &H40
    
    ' PRBUF      - Printer buffer (33 bytes, 33rd is NEWLINE)
    SYSVARS.PRBUFEND = 118

End Sub

Sub Write_DF()
   Dim Cnt As Integer
   Dim DTmp(32) As Byte
   Dim VTmp(1) As Byte
   DTmp(32) = &H76
   VTmp(0) = &H80
   VTmp(1) = &H76
   
   ' Write an empty DFILE area
   Put #hFile, , DTmp(32)
   
   ' 24 lines of D_FILE data
   For Cnt = 0 To 23
   Put #hFile, , DTmp
   Next
   ' Write and empty VARS area
   Put #hFile, , VTmp

End Sub
Sub Write_DFDiet()
   Dim Cnt As Integer
   Dim DTmp As Byte
   Dim VTmp(1) As Byte
   
   DTmp = &H76
   VTmp(0) = &H80
   VTmp(1) = &H76
   
   ' 24 lines of D_FILE data
   For Cnt = 0 To 23
   Put #hFile, , DTmp
   Next
   ' Write and empty VARS area
   Put #hFile, , VTmp

End Sub


Sub Disp_Err(ErrNumb As Byte, Optional Comment As String = "")
Dim ErrStr As String
If ErrNumb <> 0 And ErrNumb <> 20 Then
ErrIndex = ErrIndex + 1
FrmMain.Comments = FrmMain.Comments + "Error#" + Format(ErrIndex, "####") + ":"
End If

Select Case ErrNumb
Case 0
ErrStr = "Started." + vbCrLf
Case 1
ErrStr = "Label start line must be in the range 0 to 9999." + vbCrLf

Case 2
ErrStr = "Label line incr. must be in the range 1 to 9990." + vbCrLf

Case 3
ErrStr = "line " & InputLine & ": invalid block graphics. (Basic line " + Str(CurNBLn) + ")" + vbCrLf

Case 4
ErrStr = "line " & InputLine & ": Non-mappable character in input (Basic line " + Str(CurNBLn) + ")" + vbCrLf

Case 5
ErrStr = "Could not open input file." + vbCrLf

Case 6
ErrStr = "line " & InputLine & ": missing line number" + vbCrLf

Case 7
ErrStr = "line " & InputLine & ": line no. not greater than previous one" + vbCrLf

Case 8
ErrStr = "line " & InputLine & ": line no. out of range" + vbCrLf

Case 9
ErrStr = "line " & InputLine & ": line no. already exists." + vbCrLf

Case 10
ErrStr = "program too big to use a 16k ram Pack!" + vbCrLf

Case 11
ErrStr = "line " & InputLine & ": Zx Double convertion error [" & Comment & "] in Output (Basic line " + Str(CurNBLn) + ")" + vbCrLf

Case 20
ErrStr = "Success." + vbCrLf

End Select
FrmMain.Comments = FrmMain.Comments + ErrStr
End Sub
Function dbl2zx81(Num As Single) As Zx81_Long
 'On Error Resume Next
 
' * Converts a double to an inline-basic-style ZX81 floating point number.
' *
' * IN:      num  - Number to convert (dbl)
' * OUT:     &exp - Exponent (integer)
' * OUT:     &man - Mantissa (char)
' *

Dim IntNum As Double
Dim tmpint1 As Double
Dim tmpint2 As Double

Dim TmpVal As String
Dim Expon As Double

'    /* Special case for zero */
    If Num = 0 Then
    dbl2zx81.Exp = 0
    dbl2zx81.man = 0
     Exit Function
    End If
    

    
'    /* If negative work with the absolute value */
    If Num < 0 Then Num = -Num

dbl2zx81.Exp = Int(Log(Num) / Log(2))


If dbl2zx81.Exp < -129 Or dbl2zx81.Exp > 126 Then Exit Function

IntNum = ((Num / (2 ^ (dbl2zx81.Exp + Expon))) * 2147483648#)

tmpint1 = Int((IntNum) / 65536) '  65536=&h10000

tmpint2 = (IntNum) - (tmpint1 * 65536) ' 65536=&h10000
tmpint1 = tmpint1 And 32767 ' 32767=&h7FFF

TmpVal = Hex16(UnsignedToLong(tmpint1)) & Hex16(UnsignedToLong(tmpint2))
    
    dbl2zx81.man = TmpVal
    dbl2zx81.Exp = dbl2zx81.Exp + 129
    Exit Function

Dbl_ERR:
    Disp_Err 11, Str(Num)
End Function
Sub Add_Num(STRnumber As String)

Dim NumRet As Zx81_Long
Dim Cmp As Long, L As Integer
Dim ExpSTR As String

'intercept exponent.
'If InStr(1, UCase(STRnumber), "E") > 0 Then
'Debug.Print
'End If

'intercept exponent.
'If InStr(1, UCase(STRnumber), ".") > 0 Then
'Debug.Print
'End If


If Val(STRnumber) = 0.5 Then
NumRet.Exp = &H7F
NumRet.man = "7FFFFFFF"
Else
NumRet = dbl2zx81(Val(STRnumber))
End If

    ZxOffset = ZxOffset + 6
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset - 6) = &H7E
    ZXbuffer(ZxOffset - 5) = NumRet.Exp
    
    Cmp = 0
    For L = 3 To 0 Step -1
    ZXbuffer(ZxOffset - L - 1) = CByte(Val("&h" & Mid(NumRet.man, (Cmp * 2) + 1, 2)))
    Cmp = Cmp + 1
    Next

End Sub
Sub Save_P(File_Name As String)
Dim PHeader As P_header

If Dir(File_Name) <> "" Then Kill File_Name

hFile = FreeFile
     Open File_Name For Binary Access Write Lock Write As #hFile
     Init_SyS_VARS PHeader
     Put #hFile, 1, PHeader
     Put #hFile, , ZXbuffer
         If FrmMain.Diet_DF > 0 Then Write_DFDiet Else Write_DF
     Close #hFile
Disp_Err 20
End Sub

' Retrive name in a long file name string ( "c:\vb\tmp\file.txt" -> "file.txt" )
Public Function Cut_Name(ByRef Ln_file As String) As String
Dim LastSlash, scan_path As Integer
Dim char_path As String * 1
Dim lng_file As String
lng_file = GetLongPathName(Ln_file)
Ln_file = lng_file

'If Ln_file = "" Then Cut_Name = "": Exit Function
If InStr(Ln_file, "\") = 0 Then Cut_Name = Ln_file: Exit Function
   
    scan_path = Len(Ln_file)
    Do While InStr(1, Mid(Ln_file, scan_path, 1), "\", vbBinaryCompare) = 0
     scan_path = scan_path - 1
    Loop
 LastSlash = scan_path
Cut_Name = Trim(Right(Ln_file, Len(Ln_file) - LastSlash))

End Function
Public Function GetLongPathName(Shortpath As String) As String
   Dim s As String
   Dim i As Long
   
   i = 255
   s = String(i, 0)
   GetLongPathNameA Shortpath, s, i
   
   GetLongPathName = Left$(s, InStr(s, Chr$(0)) - 1)
End Function

' Internal function cut attributes "disk.TXT" = "disk"
Public Function Cut_attr(char As String) As String

For Cmp = Len(char) To 1 Step -1
If Mid(char, Cmp, 1) = "." Then Cut_attr = Mid(char, 1, Cmp - 1): Exit For
If Mid(char, Cmp, 1) = "\" Then Cut_attr = char: Exit For
Next Cmp
End Function

Function Get_ASM(Text As String) As String
Dim TmpChar As String
Dim TmpVal As Long
Dim ScanChar As String * 1
Dim BaseFlag As Byte

'Retriev Base Specs.
   TmpChar = ""
   ScanChar = Text
   Do While ScanChar = ";" Or ScanChar = "," Or ScanChar = ":" Or ScanChar = "/" Or ScanChar = "-" Or ScanChar = " "
      Text = Right(Text, Len(Text) - 1)
      If ScanChar = "]" Or Trim(Text) = "" Then GoTo endscan1:
      ScanChar = Text
   Loop

Select Case UCase(Left(Text, 3))
    Case "HEX"
        BaseFlag = 1
    Case "DEC"
        BaseFlag = 2
    Case "BIN"
        BaseFlag = 3
    Case Else
        ErrIndex = ErrIndex + 1
        FrmMain.Comments = FrmMain.Comments & "Error#" & Format(ErrIndex, "####") & ":"
        FrmMain.Comments = FrmMain.Comments & "line " & InputLine & ": [" & UCase(Left(Text, 3)) & "] invalid Base (BIN,HEX or DEC)." + vbCrLf
        Exit Function
End Select

    Text = Right(Text, Len(Text) - 3)
    
Do Until Trim(Text) = "" Or ScanChar = "]"
   TmpChar = ""
   ScanChar = Text
   Do While ScanChar = ";" Or ScanChar = "," Or ScanChar = ":" Or ScanChar = " " Or ScanChar = " "
      Text = Right(Text, Len(Text) - 1)
      ScanChar = Text
   Loop
         If ScanChar = "]" Then GoTo endscan1:

   Do
   
Select Case BaseFlag
   Case 1
     If Not Is_HEX(Asc(ScanChar)) Then
      ErrIndex = ErrIndex + 1
      FrmMain.Comments = FrmMain.Comments & "Error#" & Format(ErrIndex, "####") & ":"
      FrmMain.Comments = FrmMain.Comments & "line " & InputLine & ": [" & ScanChar & "] invalid hexadecimal character." + vbCrLf
     Else
      TmpChar = TmpChar + ScanChar
     End If
    Case 2
      If Not Is_DEC(Asc(ScanChar)) Then
      ErrIndex = ErrIndex + 1
      FrmMain.Comments = FrmMain.Comments & "Error#" & Format(ErrIndex, "####") & ":"
      FrmMain.Comments = FrmMain.Comments & "line " & InputLine & ": [" & ScanChar & "] invalid decimal character." + vbCrLf
     Else
      TmpChar = TmpChar + ScanChar
     End If
    Case 3
      If Not Is_BIN(Asc(ScanChar)) Then
      ErrIndex = ErrIndex + 1
      FrmMain.Comments = FrmMain.Comments & "Error#" & Format(ErrIndex, "####") & ":"
      FrmMain.Comments = FrmMain.Comments & "line " & InputLine & ": [" & ScanChar & "] invalid binary character." + vbCrLf
     Else
      TmpChar = TmpChar + ScanChar
     End If
End Select

   Text = Right(Text, Len(Text) - 1)
        ScanChar = Text
   Loop Until ScanChar = ";" Or ScanChar = "," Or ScanChar = ":" Or ScanChar = " " Or ScanChar = "]"
      

   TmpChar = Trim(TmpChar)
   
   Select Case BaseFlag
   Case 1
   TmpVal = ASChex(TmpChar)
   Case 2
   TmpVal = Val(TmpChar)
   Case 3
   TmpVal = BinToDbl(TmpChar)
   End Select
   
   If TmpVal > 255 Then
    ErrIndex = ErrIndex + 1
    FrmMain.Comments = FrmMain.Comments + "Error#" + Format(ErrIndex, "####") & ":"
    FrmMain.Comments = FrmMain.Comments + "line " & InputLine & ": [" & TmpChar & "] too big." + vbCrLf
   Else
    ReDim Preserve ZXbuffer(ZxOffset)
    ZXbuffer(ZxOffset) = CByte(TmpVal)
    ZxOffset = ZxOffset + 1
   End If
   ScanChar = Text
Loop

endscan1:

     If ScanChar = "]" Then Text = Right(Text, Len(Text) - 1)
     
Get_ASM = Text

End Function




Sub Load_PFile(Filename As String)

Dim m_iLen, m_iFile, PHeader As P_header

m_iFile = FreeFile
      
     Open Filename For Binary Access Read Lock Write As #m_iFile
         m_iLen = LOF(m_iFile)
        Get #m_iFile, 1, PHeader
        Dim len_bas
         len_bas = UinttoS(PHeader.D_FILE) - 16509
       On Error GoTo err1
         ReDim Prog_ZX(0 To len_bas - 1) As Byte
         Get #m_iFile, 117, Prog_ZX()
err1:
     Close #m_iFile
     
 
Computer = "ZX81" ' or ="SPECTRUM"
Call Conversion_text(Computer, m_iLen, 0)
        
Disp_Err 20
End Sub
Public Sub Conversion_text(Computer As String, File_Lenght As Variant, offset As Long)

Dim Cmp_Line, Tmp_Line As String, Numb_Line, Longueur_Ligne As Long
Dim a As Long

Dim TMP_CHAR As String
Dim RemBuffer As String, InfoStr As String

Dim m_iFile As Integer
m_iFile = FreeFile
     
Open FrmMain.OutputTXTn For Output As #m_iFile
    


'On Error GoTo fin

Do While offset < UBound(Prog_ZX)

' Initialisation de la ligne.
Cmp_Line = 0
Tmp_Line = ""

' Numrotation de ligne sur 16 bits.
Numb_Line = (CLng(Prog_ZX(offset)) * 256) + CLng(Prog_ZX(offset + 1))

Debug.Print "Line#"; Numb_Line
'Traduction ligne par ligne
Longueur_Ligne = CLng(Prog_ZX(offset + 3)) * 256 + CLng(Prog_ZX(offset + 2))

If Longueur_Ligne = 0 Or Longueur_Ligne > 16384 Then Exit Do

'Lecture et dcodage spars des lignes REMs
If Prog_ZX(offset + 4) = 234 And Computer = "ZX81" And Longueur_Ligne > 2 Then
RemBuffer = ""
For a = offset + 5 To offset + Longueur_Ligne + 2
RemBuffer = RemBuffer + Chr(Prog_ZX(a))
Next a
InfoStr = Get_InfoREM(offset + 5, offset + Longueur_Ligne + 2)
Tmp_Line = Get_Rem(RemBuffer)
GoTo Nx_Line
End If

Do While Cmp_Line < Longueur_Ligne - 1 ' And offset + 117 < UBound(Prog_ZX)


'Occulter les valeurs pour les car. ascii 126 (Code FP interne en 5 octets)
'Sauf pour les lignes REM, rservation des codes machines, ce n'est donc pas un code FP.
If offset + Cmp_Line + 4 > UBound(Prog_ZX) Then Exit Do
On Error Resume Next
If Prog_ZX(offset + Cmp_Line + 4) = 126 And Prog_ZX(offset + 5) <> 234 Then
Cmp_Line = Cmp_Line + 5: GoTo FP_Code
End If


' ZxText2P graphics chars.
If FrmMain.Format.ListIndex = 1 Then
TMP_CHAR = Conv_SPGrByte(Prog_ZX(offset + Cmp_Line + 4))
If TMP_CHAR <> "" Then
Tmp_Line = Tmp_Line + TMP_CHAR
GoTo FP_Code
End If
End If

' ZmakeBas graphics chars.
If FrmMain.Format.ListIndex = 2 And Computer = "SPECTRUM" Then
  If Prog_ZX(offset + Cmp_Line + 4) > 131 And Prog_ZX(offset + Cmp_Line + 4) < 143 Then
     TMP_CHAR = Conv_SPGrByteSPECT(Prog_ZX(offset + Cmp_Line + 4))
      If TMP_CHAR <> "" Then
        Tmp_Line = Tmp_Line + TMP_CHAR
        GoTo FP_Code
      End If
   End If
End If

If FrmMain.Cbi.Value > 0 Then CBI_SW = True

Select Case Prog_ZX(offset + Cmp_Line + 4)

'Conversion Ascii ZX vers PC
Case 0
TMP_CHAR = " "
Case 1
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB6) Else TMP_CHAR = "{1}"
Case 2
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB7) Else TMP_CHAR = "{2}"
Case 3
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB8) Else TMP_CHAR = "{7}"
Case 4
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB9) Else TMP_CHAR = "{4}"
Case 5
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HBA) Else TMP_CHAR = "{5}"
Case 6
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HBB) Else TMP_CHAR = "{T}"
Case 7
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HBC) Else TMP_CHAR = "{E}"
Case 8
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HBD) Else TMP_CHAR = "{A}"
Case 9
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HBE) Else TMP_CHAR = "{D}"
Case 10
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HBF) Else TMP_CHAR = "{S}"
Case 11
TMP_CHAR = Chr(&H22)
Case 12
TMP_CHAR = Chr(&HA3)
Case 13
TMP_CHAR = "$"
Case 14
TMP_CHAR = ":": ' Encoded number  (+5)
If Computer = "SPECTRUM" Then TMP_CHAR = "": Cmp_Line = Cmp_Line + 5: GoTo FP_Code
Case 15
TMP_CHAR = "?"
Case 16
TMP_CHAR = "(": ' Embedded INK    (+1)
If Computer = "SPECTRUM" Then TMP_CHAR = ""
Case 17
TMP_CHAR = ")": ' Embedded PAPER  (+1)
If Computer = "SPECTRUM" Then TMP_CHAR = ""
Case 18
TMP_CHAR = ">": ' Embedded FLASH  (+1)
If Computer = "SPECTRUM" Then TMP_CHAR = ""
Case 19
TMP_CHAR = "<": ' Embedded BRIGHT (+1)
If Computer = "SPECTRUM" Then TMP_CHAR = ""
Case 20
TMP_CHAR = "=": ' Embedded INVERSE(+1)
If Computer = "SPECTRUM" Then TMP_CHAR = ""
Case 21
TMP_CHAR = "+": ' Embedded OVER   (+1)
If Computer = "SPECTRUM" Then TMP_CHAR = ""

Case 22
TMP_CHAR = "-": ' Embedded AT   (+2)
If Computer = "SPECTRUM" Then TMP_CHAR = "": Cmp_Line = Cmp_Line + 2: GoTo FP_Code

Case 23
TMP_CHAR = "*": ' Embedded TAB  (+2)
If Computer = "SPECTRUM" Then TMP_CHAR = "": Cmp_Line = Cmp_Line + 2: GoTo FP_Code

Case 24
TMP_CHAR = "/"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 25
TMP_CHAR = ";"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 26
TMP_CHAR = ","
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 27
TMP_CHAR = "."
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 28
TMP_CHAR = "0"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 29
TMP_CHAR = "1"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 30
TMP_CHAR = "2"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 31
TMP_CHAR = "3"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 32
TMP_CHAR = "4"
If Computer = "SPECTRUM" Then TMP_CHAR = " "
Case 33
TMP_CHAR = "5"
If Computer = "SPECTRUM" Then TMP_CHAR = "!"
Case 34
TMP_CHAR = "6"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(&H22)
Case 35
TMP_CHAR = "7"
If Computer = "SPECTRUM" Then TMP_CHAR = "#"
Case 36
TMP_CHAR = "8"
If Computer = "SPECTRUM" Then TMP_CHAR = "$"
Case 37
TMP_CHAR = "9"
If Computer = "SPECTRUM" Then TMP_CHAR = "%"
Case 38
TMP_CHAR = "A"
If Computer = "SPECTRUM" Then TMP_CHAR = "&"
Case 39
TMP_CHAR = "B"
If Computer = "SPECTRUM" Then TMP_CHAR = "'"
Case 40
TMP_CHAR = "C"
If Computer = "SPECTRUM" Then TMP_CHAR = "("
Case 41
TMP_CHAR = "D"
If Computer = "SPECTRUM" Then TMP_CHAR = ")"
Case 42
TMP_CHAR = "E"
If Computer = "SPECTRUM" Then TMP_CHAR = "*"
Case 43
TMP_CHAR = "F"
If Computer = "SPECTRUM" Then TMP_CHAR = "+"
Case 44
TMP_CHAR = "G"
If Computer = "SPECTRUM" Then TMP_CHAR = ","
Case 45
TMP_CHAR = "H"
If Computer = "SPECTRUM" Then TMP_CHAR = "-"
Case 46
TMP_CHAR = "I"
If Computer = "SPECTRUM" Then TMP_CHAR = "."
Case 47
TMP_CHAR = "J"
If Computer = "SPECTRUM" Then TMP_CHAR = "/"
Case 48
TMP_CHAR = "K"
If Computer = "SPECTRUM" Then TMP_CHAR = "0"
Case 49
TMP_CHAR = "L"
If Computer = "SPECTRUM" Then TMP_CHAR = "1"
Case 50
TMP_CHAR = "M"
If Computer = "SPECTRUM" Then TMP_CHAR = "2"
Case 51
TMP_CHAR = "N"
If Computer = "SPECTRUM" Then TMP_CHAR = "3"
Case 52
TMP_CHAR = "O"
If Computer = "SPECTRUM" Then TMP_CHAR = "4"
Case 53
TMP_CHAR = "P"
If Computer = "SPECTRUM" Then TMP_CHAR = "5"
Case 54
TMP_CHAR = "Q"
If Computer = "SPECTRUM" Then TMP_CHAR = "6"
Case 55
TMP_CHAR = "R"
If Computer = "SPECTRUM" Then TMP_CHAR = "7"
Case 56
TMP_CHAR = "S"
If Computer = "SPECTRUM" Then TMP_CHAR = "8"
Case 57
TMP_CHAR = "T"
If Computer = "SPECTRUM" Then TMP_CHAR = "9"
Case 58
TMP_CHAR = "U"
If Computer = "SPECTRUM" Then TMP_CHAR = ":"
Case 59
TMP_CHAR = "V"
If Computer = "SPECTRUM" Then TMP_CHAR = ";"
Case 60
TMP_CHAR = "W"
If Computer = "SPECTRUM" Then TMP_CHAR = "<"
Case 61
TMP_CHAR = "X"
If Computer = "SPECTRUM" Then TMP_CHAR = "="
Case 62
TMP_CHAR = "Y"
If Computer = "SPECTRUM" Then TMP_CHAR = ">"
Case 63
TMP_CHAR = "Z"
If Computer = "SPECTRUM" Then TMP_CHAR = "?"
Case 64
TMP_CHAR = "RND"
If Computer = "SPECTRUM" Then TMP_CHAR = "@"
Case 65
TMP_CHAR = "INKEY$"
If Computer = "SPECTRUM" Then TMP_CHAR = "A"
Case 66
TMP_CHAR = "PI"
If Computer = "SPECTRUM" Then TMP_CHAR = "B"
Case 67
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "CALL " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "C"
Case 68
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "ERR MSGS " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "D"
Case 69
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DPOKE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "E"
Case 70
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "ERROR " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "F"
Case 71
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "CHAR " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "G"
Case 72
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "" Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "H"
Case 73
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "TRACE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "I"
Case 74
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DRAW " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "J"
Case 75
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "UNDRAW " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "K"
Case 76
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "PROTECT " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "L"
Case 77
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "EDIT " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "M"
Case 78
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "AUTO " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "N"
Case 79
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DEF PROC " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "O"
Case 80
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "END PROC " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "P"
Case 81
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "" Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "Q"
Case 82
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DELETE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "R"
Case 83
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DO " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "S"
Case 84
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "LOOP " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "T"
Case 85
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "EXIT " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "U"
Case 86
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "UNTIL " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "V"
Case 87
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "WHILE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "W"
Case 88
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "WHEN " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "X"
Case 89
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "INDENT " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "Y"
Case 90
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "RESEQ " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "Z"
Case 91
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "OFF" Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "["
Case 92
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "CURSOR " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "\"
Case 93
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DATA " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "]"
Case 94
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "RESTORE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "^"
Case 95
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "READ " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "_"
Case 96
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "NOSTALGIC " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "`"
Case 97
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "USER " Else TMP_CHAR = "*"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "a"
Case 98
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "*" Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "b"
Case 99
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "ON" Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "c"
Case 100
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "HOME " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "d"
Case 101
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "BREAK " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "e"
Case 102
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DPEEK " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "f"
Case 103
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "LINE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "g"
Case 104
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "POP " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "h"
Case 105
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "PUSH " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "i"
Case 106
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "CLR STACK " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "j"
Case 107
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "DUP " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "k"
Case 108
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "ELSE " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "l"
Case 109
If Computer = "ZX81" Then
If CBI_SW Then TMP_CHAR = "END WHEN " Else TMP_CHAR = "?"
End If
If Computer = "SPECTRUM" Then TMP_CHAR = "m"
Case 110
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "n"
Case 111
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "o"
Case 112
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "p"
Case 113
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "q"
Case 114
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "r"
Case 115
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "s"
Case 116
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "t"
Case 117
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "u"
Case 118
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "v"
Case 119
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "w"
Case 120
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "x"
Case 121
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "y"
Case 122
If Computer = "ZX81" Then TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "z"

Case 123 To 127
TMP_CHAR = "?"
If Computer = "SPECTRUM" Then
TMP_CHAR = Chr(Prog_ZX(offset + Cmp_Line + 4))
If Prog_ZX(offset + Cmp_Line + 4) = 127 And GRAPHIC_MODE Then TMP_CHAR = "\*" ' Copyright
End If
Case 128
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HAB) Else TMP_CHAR = "[ ]"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(128)
Case 129
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HAC) Else TMP_CHAR = "{Q}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(129)
Case 130
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HAA) Else TMP_CHAR = "{W}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(130)
Case 131
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HAE) Else TMP_CHAR = "{6}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(131)
Case 132
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HAF) Else TMP_CHAR = "{R}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(132)
Case 133
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB0) Else TMP_CHAR = "{8}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(133)
Case 134
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB1) Else TMP_CHAR = "{Y}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(134)
Case 135
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB2) Else TMP_CHAR = "{E}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(135)
Case 136
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB3) Else TMP_CHAR = "{H}"
If Computer = "SPECTRUM" Then TMP_CHAR = IIf(GRAPHIC_MODE, Chr(136), "{H}")
Case 137
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB4) Else TMP_CHAR = "{G}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(137)
Case 138
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&HB5) Else TMP_CHAR = "{F}"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(138)
Case 139
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H86) Else TMP_CHAR = "[" & Chr(&H22) & "]"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(139)
Case 140
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H87) Else TMP_CHAR = "[]"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(140)
Case 141
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H88) Else TMP_CHAR = "[$]"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(141)
Case 142
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H89) Else TMP_CHAR = "[:]"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(142)
Case 143
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H8A) Else TMP_CHAR = "[?]"
If Computer = "SPECTRUM" Then TMP_CHAR = Chr(143)
Case 144
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H8B) Else TMP_CHAR = "[(]"
If Computer = "SPECTRUM" Then TMP_CHAR = "a"
Case 145
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H8C) Else TMP_CHAR = "[)]"
If Computer = "SPECTRUM" Then TMP_CHAR = "b"
Case 146
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H8D) Else TMP_CHAR = "[>]"
If Computer = "SPECTRUM" Then TMP_CHAR = "c"
Case 147
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H8E) Else TMP_CHAR = "[<]"
If Computer = "SPECTRUM" Then TMP_CHAR = "d"
Case 148
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H8F) Else TMP_CHAR = "[=]"
If Computer = "SPECTRUM" Then TMP_CHAR = "e"
Case 149
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H90) Else TMP_CHAR = "[+]"
If Computer = "SPECTRUM" Then TMP_CHAR = "f"
Case 150
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H91) Else TMP_CHAR = "[-]"
If Computer = "SPECTRUM" Then TMP_CHAR = "g"
Case 151
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H92) Else TMP_CHAR = "[*]"
If Computer = "SPECTRUM" Then TMP_CHAR = "h"
Case 152
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H93) Else TMP_CHAR = "[/]"
If Computer = "SPECTRUM" Then TMP_CHAR = "i"
Case 153
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(&H94) Else TMP_CHAR = "[;]"
If Computer = "SPECTRUM" Then TMP_CHAR = "j"
Case 154
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(143) Else TMP_CHAR = "[=]"
If Computer = "SPECTRUM" Then TMP_CHAR = "k"
Case 155
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(150) Else TMP_CHAR = "[.]"
If Computer = "SPECTRUM" Then TMP_CHAR = "l"
Case 156
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(151) Else TMP_CHAR = "[0]"
If Computer = "SPECTRUM" Then TMP_CHAR = "m"
Case 157
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(152) Else TMP_CHAR = "[1]"
If Computer = "SPECTRUM" Then TMP_CHAR = "n"
Case 158
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(153) Else TMP_CHAR = "[2]"
If Computer = "SPECTRUM" Then TMP_CHAR = "o"
Case 159
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(154) Else TMP_CHAR = "[3]"
If Computer = "SPECTRUM" Then TMP_CHAR = "p"
Case 160
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(155) Else TMP_CHAR = "[4]"
If Computer = "SPECTRUM" Then TMP_CHAR = "q"
Case 161
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(156) Else TMP_CHAR = "[5]"
If Computer = "SPECTRUM" Then TMP_CHAR = "r"
Case 162
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(157) Else TMP_CHAR = "[6]"
If Computer = "SPECTRUM" Then TMP_CHAR = "s"
Case 163
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(158) Else TMP_CHAR = "[7]"
If Computer = "SPECTRUM" Then TMP_CHAR = "t"
Case 164
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(159) Else TMP_CHAR = "[8]"
If Computer = "SPECTRUM" Then TMP_CHAR = "u"
Case 165
If GRAPHIC_MODE = True Then TMP_CHAR = Chr(160) Else TMP_CHAR = "[9]"
If Computer = "SPECTRUM" Then TMP_CHAR = "v"
Case 166
If GRAPHIC_MODE = True Then TMP_CHAR = "a" Else TMP_CHAR = "[A]"
If Computer = "SPECTRUM" Then TMP_CHAR = "w"
Case 167
If GRAPHIC_MODE = True Then TMP_CHAR = "b" Else TMP_CHAR = "[B]"
If Computer = "SPECTRUM" Then TMP_CHAR = "x"
Case 168
If GRAPHIC_MODE = True Then TMP_CHAR = "c" Else TMP_CHAR = "[C]"
If Computer = "SPECTRUM" Then TMP_CHAR = "y"
Case 169
If GRAPHIC_MODE = True Then TMP_CHAR = "d" Else TMP_CHAR = "[D]"
If Computer = "SPECTRUM" Then TMP_CHAR = "z"
Case 170
If GRAPHIC_MODE = True Then TMP_CHAR = "e" Else TMP_CHAR = "[E]"
If Computer = "SPECTRUM" Then TMP_CHAR = "SCREEN$ "
Case 171
If GRAPHIC_MODE = True Then TMP_CHAR = "f" Else TMP_CHAR = "[F]"
If Computer = "SPECTRUM" Then TMP_CHAR = "ATTR "
Case 172
If GRAPHIC_MODE = True Then TMP_CHAR = "g" Else TMP_CHAR = "[G]"
If Computer = "SPECTRUM" Then TMP_CHAR = "AT "
Case 173
If GRAPHIC_MODE = True Then TMP_CHAR = "h" Else TMP_CHAR = "[H]"
If Computer = "SPECTRUM" Then TMP_CHAR = "TAB "
Case 174
If GRAPHIC_MODE = True Then TMP_CHAR = "i" Else TMP_CHAR = "[I]"
If Computer = "SPECTRUM" Then TMP_CHAR = "VAL$ "
Case 175
If GRAPHIC_MODE = True Then TMP_CHAR = "j" Else TMP_CHAR = "[J]"
If Computer = "SPECTRUM" Then TMP_CHAR = "CODE "
Case 176
If GRAPHIC_MODE = True Then TMP_CHAR = "k" Else TMP_CHAR = "[K]"
If Computer = "SPECTRUM" Then TMP_CHAR = "VAL "
Case 177
If GRAPHIC_MODE = True Then TMP_CHAR = "l" Else TMP_CHAR = "[L]"
If Computer = "SPECTRUM" Then TMP_CHAR = "LEN "
Case 178
If GRAPHIC_MODE = True Then TMP_CHAR = "m" Else TMP_CHAR = "[M]"
If Computer = "SPECTRUM" Then TMP_CHAR = "SIN "
Case 179
If GRAPHIC_MODE = True Then TMP_CHAR = "n" Else TMP_CHAR = "[N]"
If Computer = "SPECTRUM" Then TMP_CHAR = "COS "
Case 180
If GRAPHIC_MODE = True Then TMP_CHAR = "o" Else TMP_CHAR = "[O]"
If Computer = "SPECTRUM" Then TMP_CHAR = "TAN "
Case 181
If GRAPHIC_MODE = True Then TMP_CHAR = "p" Else TMP_CHAR = "[P]"
If Computer = "SPECTRUM" Then TMP_CHAR = "ASN "
Case 182
If GRAPHIC_MODE = True Then TMP_CHAR = "q" Else TMP_CHAR = "[Q]"
If Computer = "SPECTRUM" Then TMP_CHAR = "ACS "
Case 183
If GRAPHIC_MODE = True Then TMP_CHAR = "r" Else TMP_CHAR = "[R]"
If Computer = "SPECTRUM" Then TMP_CHAR = "ATN "
Case 184
If GRAPHIC_MODE = True Then TMP_CHAR = "s" Else TMP_CHAR = "[S]"
If Computer = "SPECTRUM" Then TMP_CHAR = "LN "
Case 185
If GRAPHIC_MODE = True Then TMP_CHAR = "t" Else TMP_CHAR = "[T]"
If Computer = "SPECTRUM" Then TMP_CHAR = "EXP "
Case 186
If GRAPHIC_MODE = True Then TMP_CHAR = "u" Else TMP_CHAR = "[U]"
If Computer = "SPECTRUM" Then TMP_CHAR = "INT "
Case 187
If GRAPHIC_MODE = True Then TMP_CHAR = "v" Else TMP_CHAR = "[V]"
If Computer = "SPECTRUM" Then TMP_CHAR = "SQR "
Case 188
If GRAPHIC_MODE = True Then TMP_CHAR = "w" Else TMP_CHAR = "[W]"
If Computer = "SPECTRUM" Then TMP_CHAR = "SGN "
Case 189
If GRAPHIC_MODE = True Then TMP_CHAR = "x" Else TMP_CHAR = "[X]"
If Computer = "SPECTRUM" Then TMP_CHAR = "ABS "
Case 190
If GRAPHIC_MODE = True Then TMP_CHAR = "y" Else TMP_CHAR = "[Y]"
If Computer = "SPECTRUM" Then TMP_CHAR = "PEEK "
Case 191
If GRAPHIC_MODE = True Then TMP_CHAR = "z" Else TMP_CHAR = "[Z]"
If Computer = "SPECTRUM" Then TMP_CHAR = "IN "
Case 192
TMP_CHAR = Chr(&HC0)
If Computer = "SPECTRUM" Then TMP_CHAR = "USR "
Case 193
TMP_CHAR = "AT "
If Computer = "SPECTRUM" Then TMP_CHAR = "STR$ "
Case 194
TMP_CHAR = "TAB "
If Computer = "SPECTRUM" Then TMP_CHAR = "CHR$ "
Case 195
TMP_CHAR = "?"
If Computer = "SPECTRUM" Then TMP_CHAR = "NOT "
Case 196
TMP_CHAR = "CODE "
If Computer = "SPECTRUM" Then TMP_CHAR = "BIN "
Case 197
TMP_CHAR = "VAL "
If Computer = "SPECTRUM" Then TMP_CHAR = " OR "
Case 198
TMP_CHAR = "LEN "
If Computer = "SPECTRUM" Then TMP_CHAR = " AND "
Case 199
TMP_CHAR = "SIN "
If Computer = "SPECTRUM" Then TMP_CHAR = "<="
Case 200
TMP_CHAR = "COS "
If Computer = "SPECTRUM" Then TMP_CHAR = ">="
Case 201
TMP_CHAR = "TAN "
If Computer = "SPECTRUM" Then TMP_CHAR = "<>"
Case 202
TMP_CHAR = "ASN "
If Computer = "SPECTRUM" Then TMP_CHAR = " LINE "
Case 203
TMP_CHAR = "ACS "
If Computer = "SPECTRUM" Then TMP_CHAR = " THEN "
Case 204
TMP_CHAR = "ATN "
If Computer = "SPECTRUM" Then TMP_CHAR = " TO "
Case 205
TMP_CHAR = "LN "
If Computer = "SPECTRUM" Then TMP_CHAR = " STEP "
Case 206
TMP_CHAR = "EXP "
If Computer = "SPECTRUM" Then TMP_CHAR = " DEF FN "
Case 207
TMP_CHAR = "INT "
If Computer = "SPECTRUM" Then TMP_CHAR = " CAT "
Case 208
TMP_CHAR = "SQR "
If Computer = "SPECTRUM" Then TMP_CHAR = " FORMAT "
Case 209
TMP_CHAR = "SGN "
If Computer = "SPECTRUM" Then TMP_CHAR = " MOVE "
Case 210
TMP_CHAR = "ABS "
If Computer = "SPECTRUM" Then TMP_CHAR = " ERASE "
Case 211
TMP_CHAR = "PEEK "
If Computer = "SPECTRUM" Then TMP_CHAR = " OPEN #"
Case 212
TMP_CHAR = "USR "
If Computer = "SPECTRUM" Then TMP_CHAR = " CLOSE #"
Case 213
TMP_CHAR = "STR$ "
If Computer = "SPECTRUM" Then TMP_CHAR = " MERGE "
Case 214
TMP_CHAR = "CHR$ "
If Computer = "SPECTRUM" Then TMP_CHAR = " VERIFY "
Case 215
TMP_CHAR = "NOT "
If Computer = "SPECTRUM" Then TMP_CHAR = " BEEP "
Case 216
TMP_CHAR = "**"
If Computer = "SPECTRUM" Then TMP_CHAR = " CERCLE "
Case 217
TMP_CHAR = " OR "
If Computer = "SPECTRUM" Then TMP_CHAR = " INK "
Case 218
TMP_CHAR = " AND "
If Computer = "SPECTRUM" Then TMP_CHAR = " PAPER "
Case 219
TMP_CHAR = "<="
If Computer = "SPECTRUM" Then TMP_CHAR = " FLASH "
Case 220
TMP_CHAR = ">="
If Computer = "SPECTRUM" Then TMP_CHAR = " BRIGHT "
Case 221
TMP_CHAR = "<>"
If Computer = "SPECTRUM" Then TMP_CHAR = " INVERSE "
Case 222
TMP_CHAR = " THEN "
If Computer = "SPECTRUM" Then TMP_CHAR = " OVER "
Case 223
TMP_CHAR = " TO "
If Computer = "SPECTRUM" Then TMP_CHAR = " OUT "
Case 224
TMP_CHAR = " STEP "
If Computer = "SPECTRUM" Then TMP_CHAR = " LPRINT "
Case 225
TMP_CHAR = "LPRINT "
If Computer = "SPECTRUM" Then TMP_CHAR = " LLIST "
Case 226
TMP_CHAR = "LLIST "
If Computer = "SPECTRUM" Then TMP_CHAR = " STOP "
Case 227
TMP_CHAR = "STOP "
If Computer = "SPECTRUM" Then TMP_CHAR = " READ "
Case 228
TMP_CHAR = "SLOW "
If Computer = "SPECTRUM" Then TMP_CHAR = " DATA "
Case 229
TMP_CHAR = "FAST "
If Computer = "SPECTRUM" Then TMP_CHAR = " RESTORE "
Case 230
TMP_CHAR = "NEW "
If Computer = "SPECTRUM" Then TMP_CHAR = " NEW "
Case 231
TMP_CHAR = "SCROLL "
If Computer = "SPECTRUM" Then TMP_CHAR = " BORDER "
Case 232
TMP_CHAR = "CONT "
If Computer = "SPECTRUM" Then TMP_CHAR = " CONTINUE "
Case 233
TMP_CHAR = "DIM "
If Computer = "SPECTRUM" Then TMP_CHAR = " DIM "
Case 234
TMP_CHAR = " REM"
If Computer = "SPECTRUM" Then TMP_CHAR = " REM "
Case 235
TMP_CHAR = "FOR "
If Computer = "SPECTRUM" Then TMP_CHAR = " FOR "
Case 236
TMP_CHAR = "GOTO "
If Computer = "SPECTRUM" Then TMP_CHAR = " GO TO "
Case 237
TMP_CHAR = "GOSUB "
If Computer = "SPECTRUM" Then TMP_CHAR = " GO SUB "
Case 238
TMP_CHAR = "INPUT "

Case 239
TMP_CHAR = "LOAD "

Case 240
TMP_CHAR = "LIST "

Case 241
TMP_CHAR = "LET "
Case 242
TMP_CHAR = "PAUSE "
Case 243
TMP_CHAR = "NEXT "
Case 244
TMP_CHAR = "POKE "
Case 245
TMP_CHAR = "PRINT "
Case 246
TMP_CHAR = "PLOT "
Case 247
TMP_CHAR = "RUN "
Case 248
TMP_CHAR = "SAVE "
Case 249
TMP_CHAR = "RAND "
If Computer = "SPECTRUM" Then TMP_CHAR = " RANDOMIZE "
Case 250
TMP_CHAR = "IF "
Case 251
TMP_CHAR = "CLS "
Case 252
TMP_CHAR = "UNPLOT "
If Computer = "SPECTRUM" Then TMP_CHAR = " DRAW "
Case 253
TMP_CHAR = "CLEAR "
Case 254
TMP_CHAR = "RETURN "
Case 255
TMP_CHAR = "COPY "
End Select

Tmp_Line = Tmp_Line + TMP_CHAR

FP_Code:
Cmp_Line = Cmp_Line + 1

Loop

Nx_Line:
If InfoStr <> "" Then
         Print #m_iFile, InfoStr: InfoStr = ""
End If

         Print #m_iFile, Format_Right(Val(Numb_Line)) & " " & Tmp_Line

offset = offset + Longueur_Ligne + 4

Loop
fin:

    Close #m_iFile
    


End Sub


Sub Load_SnaFile(Filename As String)
Dim m_iLen, m_iFile, Sna_header As P_header, Offset_prog As Long
Dim L_Byte As Byte, H_Byte As Byte

m_iFile = FreeFile
      
     Open Filename For Binary Access Read Lock Write As #m_iFile
         m_iLen = LOF(m_iFile)
         
        ' Get #m_iFile, 1, Sna_header
         Get #m_iFile, 7279, L_Byte
         Get #m_iFile, 7280, H_Byte
        
         ReDim Prog_ZX(0 To m_iLen) As Byte
         Get #m_iFile, 28, Prog_ZX()
     Close #m_iFile
     
' pointage de la valeur d'adressage basse du Basic Spectrum
' soit, PEEK 23635+256*PEEK 23636
' les premiers 16357 octets ne sont pas inclus dans le fichier sna ( adressage ROM )
' adresse de decalage 7279 dans le fichier sna.

Offset_prog = CLng(L_Byte) + (CLng(H_Byte) * 256)

'Offset_prog est inferieur  23296 et > 65530 c'est qu'il n'y pas de programmes Basic dans le sna!
   
If Offset_prog > 23296 And Offset_prog < 65530 Then
'Lire les lignes...
GRAPHIC_MODE = False
Call Conversion_text("SPECTRUM", m_iLen, Offset_prog - 16357 - 27)
Else
FrmMain.Comments = FrmMain.Comments & "Basic program unavailable on this Sna !" & vbCrLf
End If

Disp_Err 20
End Sub


'Convert Zx byte chars codes to ZxText2P string.

Function Conv_SPGrByte(ZxBYTE As Byte) As String

Dim Conv_str As String
Conv_str = ""

  Select Case ZxBYTE
    Case &HC0
    Conv_str = "\" & Chr(&H22) + Chr(&H22)
'    Case &H0
'    Conv_str = "\  "
    Case &H1
    Conv_str = "\' "
    Case &H2
    Conv_str = "\ '"
    Case &H3
    Conv_str = "\''"
    Case &H4
    Conv_str = "\. "
    Case &H5
    Conv_str = "\: "
    Case &H6
    Conv_str = "\.'"
    Case &H7
    Conv_str = "\:'"
    Case &H8
    Conv_str = "\##"
    Case &H9
    Conv_str = "\,,"
    Case &HA
    Conv_str = "\~~"
    Case &H80
    Conv_str = "\::"
    Case &H81
    Conv_str = "\.:"
    Case &H82
    Conv_str = "\:."
    Case &H83
    Conv_str = "\.."
    Case &H84
    Conv_str = "\':"
    Case &H85
    Conv_str = "\ :"
    Case &H86
    Conv_str = "\'."
    Case &H87
    Conv_str = "\ ."
    Case &H88
    Conv_str = "\@@"
    Case &H89
    Conv_str = "\;;"
    Case &H8A
    Conv_str = "\!!"
    Case Else
    Conv_str = ""
   End Select
   
   If ZxBYTE > 138 And ZxBYTE < 192 Then Conv_str = "%" & ZXCharToASCII((ZxBYTE And 127), False)

       
Conv_SPGrByte = Conv_str


End Function
Public Function ZXCharToASCII(ByVal cZX As Byte, Optional Func As Boolean = True, Optional ASM As Boolean = False) As String
' Convert ZX characters codes to PC Codes.
' Zx81 Memory to Pc Display.

' func =>
    If (cZX > 127 And cZX < 192) Then cZX = cZX And 63
     
 '   If (cZX And 64) = 64 Then ZXCharToASCII = "_": Exit Function

 
    Select Case cZX
    Case 0 ' // SPACE
        ZXCharToASCII = " "
    Case 11 To 13
        ' 11 = 34   "
        ' 12 = 35  /#
        ' 13 = 36  $
        ZXCharToASCII = Chr$(cZX + 23)
    Case 14
        ' 14 = :
        ZXCharToASCII = ":"
    Case 15
        ' 15 = ?
        ZXCharToASCII = "?"
    Case 16
        ' 16 = (
        ZXCharToASCII = "("
    Case 17
        ' 17 = )
        ZXCharToASCII = ")"
    Case 18
        ' 18 = >
        ZXCharToASCII = ">"
    Case 19
        ' 19 = <
        ZXCharToASCII = "<"
    Case 20
        ' 20 = =
        ZXCharToASCII = "="
    Case 21
        ' 21 = +
        ZXCharToASCII = "+"
    Case 22
        ' 22 = -
        ZXCharToASCII = "-"
    Case 23
        ' 23 = *
        ZXCharToASCII = "*"
    Case 24
        ' 24 = /
        ZXCharToASCII = "/"
    Case 25
        ' 25 = ;
        ZXCharToASCII = ";"
    Case 26
         ' 26 = ,
        ZXCharToASCII = ","
    Case 27
        ' 27 = .
        ZXCharToASCII = "."
    Case 28 To 37
        ZXCharToASCII = Chr$(cZX + 20)
    Case 38 To 63
        ZXCharToASCII = Chr$(cZX + 27)
    Case 82, 2
        If ASM Then ZXCharToASCII = "@" Else ZXCharToASCII = "_"
    Case 118
        If Not Func Then
        ZXCharToASCII = "_"
        Else
        If Not ASM Then ZXCharToASCII = "N/L" Else ZXCharToASCII = vbCrLf & vbTab
        End If
    Case 192 And Func
        ' 192 = "''"
        ZXCharToASCII = Chr$(34)
    Case 195 And Func
        ' 195 = "?"
        ZXCharToASCII = "?"
     Case 216 And Func
        ' 216 = "**"
        ZXCharToASCII = "**"
    Case 219 And Func
        ' 219 = "<="
        ZXCharToASCII = "<="
     Case 220 And Func
        ' 220 = ">="
        ZXCharToASCII = ">="
     Case 221 And Func
        ' 221 = "<>"
        ZXCharToASCII = "<>"
    Case Else
        ZXCharToASCII = "?"
    End Select
End Function

' Spectrum char. code.( Zmakebas )
' "  ", " '", "' ", "''", " .", " :", "'.", "':",
'  ". ", ".'", ": ", ":'", "..", ".:", ":.", "::"

Function Conv_SPGrByteSPECT(ZxBYTE As Byte) As String

Dim Conv_str As String
Conv_str = ""

  Select Case ZxBYTE
    Case 128
    Conv_str = "\  "
    Case 129
    Conv_str = "\ '"
    Case 130
    Conv_str = "\' "
    Case 131
    Conv_str = "\''"
    Case 132
    Conv_str = "\ ."
    Case 133
    Conv_str = "\ :"
    Case 134
    Conv_str = "\'."
    Case 135
    Conv_str = "\':"
    Case 136
    Conv_str = "\. "
    Case 137
    Conv_str = "\.'"
    Case 138
    Conv_str = "\: "
    Case 139
    Conv_str = "\:'"
    Case 140
    Conv_str = "\.."
    Case 141
    Conv_str = "\.:"
    Case 142
    Conv_str = "\:."
    Case 143
    Conv_str = "\::"
    Case Else
    Conv_str = ""
   End Select
      
Conv_SPGrByteSPECT = Conv_str
End Function


Sub Load_TapFile(Filename As String)

Dim m_iLen, m_iFile

m_iFile = FreeFile
    On Error GoTo Err_Jp
    
     Open Filename For Binary As #m_iFile
         m_iLen = LOF(m_iFile)
              
         ReDim Prog_ZX(0 To (m_iLen - 1)) As Byte
         Get #m_iFile, 1, Prog_ZX
     Close #m_iFile
    
Call Conversion_text("SPECTRUM", m_iLen, 24)
Exit Sub
Err_Jp:
     Close #m_iFile
     Disp_Err 20
End Sub

Function StoUint(Value As Long) As Uinteger
StoUint.H = CByte((Value And 65280) \ 256)
StoUint.L = CByte(Value And 255)
End Function

Function UinttoS(Value As Uinteger) As Long
UinttoS = (CLng(Value.H) * 256) + CLng(Value.L)
End Function

Function Hex8(Value As Long) As String
If Value >= &H100 Then Hex8 = "FF": Exit Function
If Value < &H10 Then Hex8 = "0" & Hex(Value) Else Hex8 = Hex(Value)
End Function

Public Function AdvHEX(dec As Single) As String
AdvHEX = ""
If dec > &HFFFF Then AdvHEX = Hex16((dec And &HFFFF0000) \ 10000) Else AdvHEX = "0000"
AdvHEX = AdvHEX + Hex16((dec And &HFFFF))
End Function
Function Hex16(Value As Double) As String
Dim lValue As Integer
Dim StrValue As String
StrValue = Hex(Value)
lValue = Len(StrValue)
If lValue < 2 Then
   Hex16 = "000" & StrValue: Exit Function
ElseIf lValue < 3 Then
   Hex16 = "00" & StrValue: Exit Function
ElseIf lValue < 4 Then
   Hex16 = "0" & StrValue: Exit Function
End If
Hex16 = Hex(Value And 65535)
' Hex8(value / &H100) & Hex8(value - (value / &H100) * &H100)
End Function
Function Hex2Dec(HexValue As String) As Integer
  Dim lsChar As String
  Dim liHBit As Integer
  Dim liLBit As Integer
  
  ' H Byte
  lsChar = Mid(HexValue, 1, 1)
  Select Case Asc(lsChar)
    Case 48 To 57 '0..9
      liHBit = Val(lsChar) * 16
    Case 65 To 70 'A..F
      liHBit = (((65 - Asc(lsChar)) * -1) + 10) * 16
  End Select
    
  ' L Byte
  lsChar = Mid(HexValue, 2, 1)
  Select Case Asc(lsChar)
    Case 48 To 57 '0..9
      liLBit = Val(lsChar)
    Case 65 To 70 'A..F
      liLBit = (65 - Asc(lsChar)) * -1 + 10
  End Select
  
  Hex2Dec = liHBit + liLBit
End Function
Function Get_Rem(Text As String) As String
Dim TmpChar As String * 1, ByteCnt

Get_Rem = " REM [HEX:\" & vbCrLf

ByteCnt = 0
Do While Text <> ""
TmpChar = Text
Text = Right(Text, Len(Text) - 1)
Get_Rem = Get_Rem & Hex8(Asc(TmpChar)) & ","
ByteCnt = ByteCnt + 1
If ByteCnt = 8 Then ByteCnt = 0: Get_Rem = Get_Rem & "\" & vbCrLf
Loop
If Right(Get_Rem, 2) = "\" & vbCrLf Then Get_Rem = Left(Get_Rem, Len(Get_Rem) - 2)
If Right(Get_Rem, 1) = "," Then Get_Rem = Left(Get_Rem, Len(Get_Rem) - 1)
Get_Rem = Get_Rem & " ]" & vbCrLf
End Function

Function Get_InfoREM(AtAdd As Long, ToADD As Long) As String
Dim AddCnt
Dim ATaddTmp
ATaddTmp = AtAdd
Get_InfoREM = vbCrLf
Get_InfoREM = Get_InfoREM & "# REM "
AddCnt = 0
Do While Prog_ZX(ATaddTmp) <> &H76 And AddCnt < 63
Get_InfoREM = Get_InfoREM & ZXCharToASCII(Prog_ZX(ATaddTmp), True)
ATaddTmp = ATaddTmp + 1: AddCnt = AddCnt + 1
If AddCnt = 32 Then Get_InfoREM = Get_InfoREM & vbCrLf & "#     "
Loop
'Get_InfoREM = Get_InfoREM & vbCrLf
End Function

Function IsZxChar(MyOffset) As Boolean
IsZxChar = False
On Error Resume Next
If (ZXbuffer(MyOffset) > 37 And ZXbuffer(MyOffset) < 64) Or (ZXbuffer(MyOffset) > 165 And ZXbuffer(MyOffset) < 192) Then IsZxChar = True
End Function

Function IsZXLetter(Mychr As Byte) As Boolean
IsZXLetter = False
On Error Resume Next
If (Mychr > 37 And Mychr < 64) Or (Mychr > 165 And Mychr < 192) Then IsZXLetter = True

End Function
