Attribute VB_Name = "ModZX80"
Option Explicit

Public Enum VARS_System
' One less than report code.
sysERR_NR = &H4000


'        Various Flags to control BASIC System.
'                                        7  1-Syntax off        0-Syntax on
'                                        6  1-Numeric result    0-String result
'                                        5  1-Evaluating function (not used)
'                                        3  1-K cursor          0-L cursor
'                                        2  1-K mode            0-L mode.
'                                        0  1-No leading space  0-Leading space.
sysFLAGS = &H4001

' Line number of current line.
sysPPC = &H4002

' Position in RAM of [K] or [L] cursor.
sysP_PTR = &H4004

' Number of current line with [>] cursor.
sysE_PPC = &H4006

' Address of start of variables area.
SYSVARS = &H4008

' Address of start of Edit Line.
sysE_LINE = &H400A

' Start of Display File.
sysD_FILE = &H400C

' Address of the start of lower screen.
sysDF_EA = &H400E

' Display File End.
sysDF_END = &H4010

' Number of lines in lower screen.
sysDF_SZ = &H4012

' The number of first line on screen.
sysS_TOP = &H4013

' Address of the character preceding
' the [S] marker.
sysX_PTR = &H4015

' Line number to which continue jumps.
sysOLDPPC = &H4017

' More flags.
'      7  1-K mode            0-L mode.
'      6  1-Numeric result    0-String result
'      5  1-Inputting         0-Editing
sysFLAGX = &H4019

' Address of next item in syntax table.
sysT_ADDR = &H401A

' The seed for the random number.
sysSEED = &H401C

' Count of frames shown since start-up.
sysFRAMES = &H401E

' Address of variable in statement.
sysDEST = &H4020

' Value of the last expression.
sysRESULT = &H4022

' Column number for print position.
sysS_POSN_X = &H4024

' Line number for print position.
sysS_POSN_Y = &H4025

'         Address of next character to be
'                interpreted.
sysCH_ADD = &H4026
End Enum

Function GetFuncZX80(txt As String) As Long
Dim txt2 As String

GetFuncZX80 = -1
Cmp_Decay = 1

txt2 = LCase(Left(txt, 2))
'If TxT2 = "<>" Or TxT2 = ">=" Or TxT2 = "<=" Or TxT2 = "**" Or bREM Then NewWord = True
If txt2 = "**" Or bREM Then NewWord = True

txt2 = LCase(Left(txt, 1))
If txt2 = Chr(192) Then Exit Function
'If Not (IsZXLetter(ASCIICharToZX80(TxT2))) Or TxT2 = Chr(20) Then NewWord = True
If NewWord = False Then Exit Function

Cmp_Decay = 9
txt = LCase(Left(txt, 9))

'9 characters.
Select Case txt
   Case "randomise"
       GetFuncZX80 = &HEF
       Exit Function
End Select

Cmp_Decay = 8
txt = LCase(Left(txt, 8))

'8 characters.
Select Case txt
   Case "continue"
       GetFuncZX80 = &HF9
       Exit Function
End Select

Cmp_Decay = 6
txt = LCase(Left(txt, 6))

'6 characters.
Select Case txt
   Case "return"
       GetFuncZX80 = &HE7
       Exit Function
   Case "go sub"
       GetFuncZX80 = &HFB
       Exit Function
End Select

Cmp_Decay = 5
txt = LCase(Left(txt, 5))

'5 characters.
Select Case txt
   Case "clear"
       GetFuncZX80 = &HFD
       Exit Function
   Case "print"
       GetFuncZX80 = &HF4
       Exit Function
   Case "input"
       GetFuncZX80 = &HEE
       Exit Function
   Case "gosub"
       GetFuncZX80 = &HFB
       Exit Function
End Select

Cmp_Decay = 4
txt = LCase(Left(txt, 4))

'4 characters.
Select Case txt
   Case "rand"
       GetFuncZX80 = &HEF
       Exit Function
   Case "save"
       GetFuncZX80 = &HEA
       Exit Function
   Case "poke"
       GetFuncZX80 = &HED
       Exit Function
   Case "next"
       GetFuncZX80 = &HF3
       Exit Function
   Case "list"
       GetFuncZX80 = &HE6
       Exit Function
   Case "load"
       GetFuncZX80 = &HFC
       Exit Function
   Case "goto"
       GetFuncZX80 = &HEC
       Exit Function
   Case "cont"
       GetFuncZX80 = &HF9
       Exit Function
   Case "stop"
       GetFuncZX80 = &HF8
       Exit Function
   Case "then"
       GetFuncZX80 = &HD5
       Exit Function
   Case "peek"
       GetFuncZX80 = 0 '&HE.............
       Exit Function
End Select

Cmp_Decay = 3
txt = LCase(Left(txt, 3))

'3 characters.
Select Case txt
   Case "cls"
       GetFuncZX80 = &HE8
       Exit Function
   Case "run"
       GetFuncZX80 = &HF7
       Exit Function
   Case "let"
       GetFuncZX80 = &HF0
       Exit Function
   Case "for"
       GetFuncZX80 = &HEB
       Exit Function
   Case "rem"
       GetFuncZX80 = &HFE
       Exit Function
   Case "dim"
       GetFuncZX80 = &HE9
       Exit Function
   Case "new"
       GetFuncZX80 = &HF6
       Exit Function
   Case "not"
       GetFuncZX80 = &HDB
       Exit Function
   Case "and"
       GetFuncZX80 = &HE0
       Exit Function
   Case "rnd"
       GetFuncZX80 = &HEF
       Exit Function

End Select

Cmp_Decay = 2
txt = LCase(Left(txt, 2))

'2 characters.
Select Case txt
   Case "if"
       GetFuncZX80 = &HFA
       Exit Function
   Case "to"
       GetFuncZX80 = &HD6
       Exit Function
   Case "or"
       GetFuncZX80 = &HE1
       Exit Function
   Case "**"
       GetFuncZX80 = &HE2
       Exit Function
End Select
Cmp_Decay = 1
txt = Left(txt, 1)
If txt = Chr(20) Then NewWord = True Else NewWord = False
End Function
Public Function ASCIICharToZX80(ByVal cZX As String) As Byte
    If cZX = "" Or cZX = Chr(224) Or cZX = Chr(255) Then ASCIICharToZX80 = 143: Exit Function
    If FrmMain.bcase.Value > 0 Then cZX = UCase(cZX)
' Convert PC Codes to ZX characters codes.
'  Pc Display to Zx80 Memory.
    
    Dim cZX_Asc As Byte
    cZX_Asc = Asc(cZX)
    
    Select Case cZX_Asc
    ' 0-9
    Case &H30 To &H39
        ASCIICharToZX80 = cZX_Asc - 20: Exit Function
     
    ' Alfa.
    Case &H41 To &H5A
        ASCIICharToZX80 = cZX_Asc - 27: Exit Function
        
    ' Inverted Alfa.
    Case &H61 To &H7A
        ASCIICharToZX80 = (Asc(UCase(cZX)) - 27) + 128: Exit Function
    
     ' inverted 0-9
    Case &H97 To &HA0
        ASCIICharToZX80 = cZX_Asc + 5: Exit Function

    Case Asc(&HD) ' , Asc(&HA)  '"N/L" vbCrLf
        ASCIICharToZX80 = 118: Exit Function

    Case Asc(" ") ' // SPACE
        ASCIICharToZX80 = 0: Exit Function
        
    Case 34
        ' 1 = 34   "
        ASCIICharToZX80 = 1: Exit Function
        
    Case Asc("")
        ' &H0C = 35   "
        ASCIICharToZX80 = &HC: Exit Function
        
     Case Asc("$")
        ' &H0D = 36   "
        ASCIICharToZX80 = &HD: Exit Function
        
     Case Asc(":")
        ' &H0E = 58   "
        ASCIICharToZX80 = &HE: Exit Function
       
     Case Asc("?")
        ' &H0F = 63   "
        ASCIICharToZX80 = &HF: Exit Function
       
    Case Asc("(")
        ASCIICharToZX80 = &HDA: Exit Function
        
    Case Asc(")")
        ASCIICharToZX80 = &HD9: Exit Function
        
    Case Asc(">")
        ASCIICharToZX80 = &HE4: Exit Function
        
    Case Asc("<")
        ASCIICharToZX80 = &HE5: Exit Function
        
    Case Asc("=")
        ASCIICharToZX80 = &HE3: Exit Function
        
    Case Asc("+")
        ASCIICharToZX80 = &HDD: Exit Function
        
    Case Asc("-")
        ASCIICharToZX80 = &HDC: Exit Function
        
    Case Asc("*")
        ASCIICharToZX80 = &HDE: Exit Function
        
    Case Asc("/")
        ASCIICharToZX80 = &HDF: Exit Function
        
    Case Asc(";")
        ASCIICharToZX80 = &HD7: Exit Function
        
    Case Asc(",")
        ASCIICharToZX80 = &HD8: Exit Function
        
    Case Asc(".")
        ASCIICharToZX80 = &H1B: Exit Function
        
        
  ' ZxBasic Specials ASCII chars.
  
  Case &HA3
  ' ""
  ASCIICharToZX80 = &HC: Exit Function
  
  
  '  "\' "
  Case &HB6
  ASCIICharToZX80 = 4: Exit Function
  
  '  "\ '"
    Case &HB7
  ASCIICharToZX80 = 5: Exit Function
    
  '  "\''"
   Case &HB8
  ASCIICharToZX80 = 131: Exit Function

  '  "\. "
  Case &HB9
  ASCIICharToZX80 = 6: Exit Function

  '  "\: "
  Case &HBA
  ASCIICharToZX80 = 2: Exit Function

  '  "\.'"
  Case &HBB
  ASCIICharToZX80 = 8: Exit Function

  '  "\##"
  Case &HBD
  ASCIICharToZX80 = 9: Exit Function

  '  "\,,"
  Case &HBE
  ASCIICharToZX80 = 10: Exit Function

  '  "\~~"
  Case &HBF
  ASCIICharToZX80 = 11: Exit Function

  '  "\.."
  Case &HAE
  ASCIICharToZX80 = 3: Exit Function

   '  "\ ."
  Case &HB2
  ASCIICharToZX80 = 7: Exit Function

   '  "\@@"= gray
  Case &HB3
  ASCIICharToZX80 = &H89: Exit Function

' Inverted Chars.
  '  "\::"
  Case &HAB
  ASCIICharToZX80 = &H80: Exit Function

  '  "\.:"
  Case &HAC
  ASCIICharToZX80 = &H84: Exit Function

  '  "\:."
  Case &HAD, &HAA
  ASCIICharToZX80 = &H85: Exit Function

  '  "\.."
  Case &HAE
  ASCIICharToZX80 = &H3: Exit Function

  '  "\':"
  Case &HAF
  ASCIICharToZX80 = &H86: Exit Function
  
    '  "\:'"
  Case &HBC
  ASCIICharToZX80 = &H87: Exit Function

  
   '  "\ :"
  Case &HB0
  ASCIICharToZX80 = &H82: Exit Function

  '  "\'."
  Case &HB1
  ASCIICharToZX80 = &H88: Exit Function

   '  "\ ."
  Case &HB2
  ASCIICharToZX80 = &H7: Exit Function

   '  "\@@"
  Case &HB3
  ASCIICharToZX80 = &H89: Exit Function

  '  "\;;"
  Case &HB4
  ASCIICharToZX80 = 138: Exit Function

  '  "\!!"
  Case &HB5
  ASCIICharToZX80 = 139: Exit Function
  
  '  Inversed "" to ")"
  Case 135 To 140
  ASCIICharToZX80 = cZX_Asc + 5: Exit Function
  
   '  Inversed "
  Case 134
  ASCIICharToZX80 = 129
 
  '  Inversed "-"
  Case 145
  ASCIICharToZX80 = 146
  
  '  Inversed "+"
  Case 144
  ASCIICharToZX80 = 147
  
  '  Inversed "*"
  Case 146
  ASCIICharToZX80 = 148

  '  Inversed "/"
  Case 147
  ASCIICharToZX80 = 149

  '  Inversed "="
  Case 143
  ASCIICharToZX80 = 150

  '  Inversed ">"
  Case 141
  ASCIICharToZX80 = 151

  '  Inversed "<"
  Case 142
  ASCIICharToZX80 = 152

  '  Inversed ";"
  Case 148
  ASCIICharToZX80 = 153

  '  Inversed ","
  Case 149
  ASCIICharToZX80 = 154

  '  Inversed "."
  Case 150
  ASCIICharToZX80 = 155


    Case Else
        Disp_Err 4
        ASCIICharToZX80 = &HF
    End Select
End Function

Sub Save_O(File_Name As String)

'ZxOffset = ZxOffset + 1
ReDim Preserve ZXbuffer(ZxOffset)
ZXbuffer(ZxOffset) = &H80

Dim Header_Zx80 As O_header
'00:
    Header_Zx80.SYS1.H = &H88: Header_Zx80.SYS1.L = &HFF ' 88FFh
    Header_Zx80.SYS2.H = &HFF: Header_Zx80.SYS2.L = &HFE ' FFFEh
    
    Header_Zx80.SYS_EOF = ZxOffset + &H4028 ' EOF 80h location
    Header_Zx80.SYS4 = Header_Zx80.SYS_EOF + 1 ' EOF 80h location+1
    Header_Zx80.SYS_VARPTR = Header_Zx80.SYS_EOF + 2 ' EOF+2
    Header_Zx80.Cur_Line = 0 ' Current Line Location.
    Header_Zx80.SYS5 = Header_Zx80.SYS_EOF + 3 ' EOF 80h location+3
    Header_Zx80.SYS6 = Header_Zx80.SYS_EOF + 4 ' EOF 80h location+5
    Header_Zx80.SYS7 = Header_Zx80.SYS_EOF + 4 ' EOF 80h location+6
    Header_Zx80.SYS8 = 2 ' 02h
    Header_Zx80.Null1 = 0 ' 0000h
    Header_Zx80.Null2 = 0 ' 0000h
    Header_Zx80.Null3 = 0 ' 0000h
    Header_Zx80.SYS10 = &H7B0  ' 07B0h
    Header_Zx80.Null4 = 0 ' 0000h
    Header_Zx80.Null5 = 0 ' 0000h
    Header_Zx80.Null6 = 0 ' 0000h
    Header_Zx80.SYS11 = &H1721 ' 1721h
    Header_Zx80.SYS12 = Header_Zx80.SYS_VARPTR ' EOF 80h location+2
    Debug.Print "LEN:"; Len(Header_Zx80)
If Dir(File_Name) <> "" Then Kill File_Name

hFile = FreeFile
     Open File_Name For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Header_Zx80
     Put #hFile, , ZXbuffer
     Close #hFile
Disp_Err 20
End Sub

Public Sub Conversion_ZX80(File_Lenght As Variant, offset As Long)

Dim Cmp_Line, Tmp_Line As String, Numb_Line, Longueur_Ligne As Long
Dim a As Long

Dim TMP_CHAR As String
Dim RemBuffer As String, InfoStr As String

Dim m_iFile As Integer
m_iFile = FreeFile
     
Open FrmMain.OutputTXTn For Output As #m_iFile

'On Error GoTo fin

Do While offset < UBound(Prog_ZX)

' Initialisation de la ligne.
Cmp_Line = 0
Tmp_Line = ""

' Numrotation de ligne sur 16 bits.
Numb_Line = (CLng(Prog_ZX(offset)) * 256) + CLng(Prog_ZX(offset + 1))

Debug.Print "Line#"; Numb_Line
'Traduction ligne par ligne
'Longueur_Ligne = CLng(Prog_ZX(offset + 3)) * 256 + CLng(Prog_ZX(offset + 2))

'If Longueur_Ligne = 0 Or Longueur_Ligne > 16384 Then Exit Do

'Test the Line lenght.
Longueur_Ligne = 1
Do While Prog_ZX(offset + 2 + Longueur_Ligne) <> &H76
Longueur_Ligne = Longueur_Ligne + 1
Loop


' End of line
'If Prog_ZX(offset + 2 + Longueur_Ligne) = &H76 Then Exit Do
'
' Pour le Zx80, la taille de la ligne est absente!
' Pour une ligne REM si on test cette ligne,
'  elle peut contenir des codes 76h sans que ce
'  soit la fin de ligne! Il faut donc trouver une
'  astuce pour viter ce problme.
'

'Lecture et dcodage spars des lignes REMs
If Prog_ZX(offset + 2) = 254 Then
RemBuffer = ""
a = offset + 3
Do While Prog_ZX(a) <> &H76 ' Longueur_Ligne
RemBuffer = RemBuffer + Chr(Prog_ZX(a))
a = a + 1
Loop

InfoStr = Get_InfoREM80(offset + 3, offset + a)
Tmp_Line = Get_Rem80(RemBuffer)
GoTo Nx_Line
End If

Do While Cmp_Line < Longueur_Ligne '- 1 ' And offset + 117 < UBound(Prog_ZX)


'Occulter les valeurs pour les car. ascii 126 (Code FP interne en 5 octets)
'Sauf pour les lignes REM, rservation des codes machines, ce n'est donc pas un code FP.
If offset + Cmp_Line + 2 > UBound(Prog_ZX) Then Exit Do
'On Error Resume Next
'If Prog_ZX(offset + Cmp_Line + 3) = 126 And Prog_ZX(offset + 3) <> 234 Then
'Cmp_Line = Cmp_Line + 3: GoTo FP_Code
'End If


' ZxText2P graphics chars.
'If FrmMain.Format.ListIndex = 1 Then
'TMP_CHAR = Conv_SPGrByte(Prog_ZX(offset + Cmp_Line + 4))
'If TMP_CHAR <> "" Then
'Tmp_Line = Tmp_Line + TMP_CHAR
'GoTo FP_Code
'End If
'End If


TMP_CHAR = ZX80_To_ASCII(Prog_ZX(offset + Cmp_Line + 2))

Tmp_Line = Tmp_Line + TMP_CHAR

FP_Code:
Cmp_Line = Cmp_Line + 1

Loop

Nx_Line:
If InfoStr <> "" Then
         Print #m_iFile, InfoStr: InfoStr = ""
End If

         Print #m_iFile, Format_Right(Val(Numb_Line)) & " " & Tmp_Line

offset = offset + Longueur_Ligne + 3

Loop
fin:

    Close #m_iFile
    

End Sub

Function ZX80_To_ASCII(ChrCode As Byte) As String

' ChrCode = Zx80 Character Code.
' Public GRAPHIC_MODE True= ZxText2P chars. / False= ZxBasic Riched Font.

ZX80_To_ASCII = "?"

Select Case ChrCode
'Conversion Ascii ZX vers PC
Case 0
ZX80_To_ASCII = " "
Case 1
ZX80_To_ASCII = Chr(&H22)
Case 2
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(186) Else ZX80_To_ASCII = "\: "
Case 3
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(174) Else ZX80_To_ASCII = "\.."
Case 4
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(182) Else ZX80_To_ASCII = "\' "
Case 5
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(183) Else ZX80_To_ASCII = "\ '"
Case 6
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(185) Else ZX80_To_ASCII = "\. "
Case 7
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(178) Else ZX80_To_ASCII = "\ ."
Case 8
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(187) Else ZX80_To_ASCII = "\.'"
Case 9
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(179) Else ZX80_To_ASCII = "\##"
Case 10
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(190) Else ZX80_To_ASCII = "\,,"
Case 11
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(191) Else ZX80_To_ASCII = "\~~"
Case 12
ZX80_To_ASCII = ""
Case 13
ZX80_To_ASCII = "$"
Case 14
ZX80_To_ASCII = ":"
Case 15
ZX80_To_ASCII = "?"
Case 16
ZX80_To_ASCII = "("
Case 17
ZX80_To_ASCII = ")"
Case 18
ZX80_To_ASCII = "-"
Case 19
ZX80_To_ASCII = "+"
Case 20
ZX80_To_ASCII = "*"
Case 21
ZX80_To_ASCII = "/"
Case 22
ZX80_To_ASCII = "="
Case 23
ZX80_To_ASCII = ">"
Case 24
ZX80_To_ASCII = "<"
Case 25 To 27
 ZX80_To_ASCII = "?"
Case 28
ZX80_To_ASCII = "0"
Case 29
ZX80_To_ASCII = "1"
Case 30
ZX80_To_ASCII = "2"
Case 31
ZX80_To_ASCII = "3"
Case 32
ZX80_To_ASCII = "4"
Case 33
ZX80_To_ASCII = "5"
Case 34
ZX80_To_ASCII = "6"
Case 35
ZX80_To_ASCII = "7"
Case 36
ZX80_To_ASCII = "8"
Case 37
ZX80_To_ASCII = "9"
Case 38
ZX80_To_ASCII = "A"
Case 39
ZX80_To_ASCII = "B"
Case 40
ZX80_To_ASCII = "C"
Case 41
ZX80_To_ASCII = "D"
Case 42
ZX80_To_ASCII = "E"
Case 43
ZX80_To_ASCII = "F"
Case 44
ZX80_To_ASCII = "G"
Case 45
ZX80_To_ASCII = "H"
Case 46
ZX80_To_ASCII = "I"
Case 47
ZX80_To_ASCII = "J"
Case 48
ZX80_To_ASCII = "K"
Case 49
ZX80_To_ASCII = "L"
Case 50
ZX80_To_ASCII = "M"
Case 51
ZX80_To_ASCII = "N"
Case 52
ZX80_To_ASCII = "O"
Case 53
ZX80_To_ASCII = "P"
Case 54
ZX80_To_ASCII = "Q"
Case 55
ZX80_To_ASCII = "R"
Case 56
ZX80_To_ASCII = "S"
Case 57
ZX80_To_ASCII = "T"
Case 58
ZX80_To_ASCII = "U"
Case 59
ZX80_To_ASCII = "V"
Case 60
ZX80_To_ASCII = "W"
Case 61
ZX80_To_ASCII = "X"
Case 62
ZX80_To_ASCII = "Y"
Case 63
ZX80_To_ASCII = "Z"
Case 64 To 127
ZX80_To_ASCII = "?"

Case 128
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(171) Else ZX80_To_ASCII = "\::"
Case 129
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(134) Else ZX80_To_ASCII = "%" & Chr(&H22)
Case 130
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(176) Else ZX80_To_ASCII = "\ :"
Case 131
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(184) Else ZX80_To_ASCII = "\''"
Case 132
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(172) Else ZX80_To_ASCII = "\.:"
Case 133
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(170) Else ZX80_To_ASCII = "\:."
Case 134
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(175) Else ZX80_To_ASCII = "\':"
Case 135
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(188) Else ZX80_To_ASCII = "\:'"
Case 136
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(177) Else ZX80_To_ASCII = "\'."
Case 137
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(189) Else ZX80_To_ASCII = "\@@"
Case 138
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(180) Else ZX80_To_ASCII = "\;;"
Case 139
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(181) Else ZX80_To_ASCII = "\!!"
Case 140
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(135) Else ZX80_To_ASCII = "%"
Case 141
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(136) Else ZX80_To_ASCII = "%$"
Case 142
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(137) Else ZX80_To_ASCII = "%:"
Case 143
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(138) Else ZX80_To_ASCII = "%?"
Case 144
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(139) Else ZX80_To_ASCII = "%("
Case 145
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(140) Else ZX80_To_ASCII = "%)"
Case 146
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(145) Else ZX80_To_ASCII = "%-"
Case 147
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(144) Else ZX80_To_ASCII = "%+"
Case 148
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(146) Else ZX80_To_ASCII = "%*"
Case 149
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(147) Else ZX80_To_ASCII = "%/"
Case 150
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(143) Else ZX80_To_ASCII = "%="
Case 151
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(141) Else ZX80_To_ASCII = "%>"
Case 152
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(142) Else ZX80_To_ASCII = "%<"
Case 153
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(148) Else ZX80_To_ASCII = "%;"
Case 154
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(149) Else ZX80_To_ASCII = "%,"
Case 155
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(150) Else ZX80_To_ASCII = "%."

Case 156 ' inverse 0.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(151) Else ZX80_To_ASCII = "%0"
Case 157 ' inverse 1.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(152) Else ZX80_To_ASCII = "%1"
Case 158 ' inverse 2.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(153) Else ZX80_To_ASCII = "%2"
Case 159 ' inverse 3.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(154) Else ZX80_To_ASCII = "%3"
Case 160 ' inverse 4.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(155) Else ZX80_To_ASCII = "%4"
Case 161 ' inverse 5.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(156) Else ZX80_To_ASCII = "%5"
Case 162 ' inverse 6.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(157) Else ZX80_To_ASCII = "%6"
Case 163 ' inverse 7.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(158) Else ZX80_To_ASCII = "%7"
Case 164 ' inverse 8.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(159) Else ZX80_To_ASCII = "%8"
Case 165 ' inverse 9.
If GRAPHIC_MODE Then ZX80_To_ASCII = Chr(160) Else ZX80_To_ASCII = "%9"

Case 166
If GRAPHIC_MODE Then ZX80_To_ASCII = "a" Else ZX80_To_ASCII = "%A"
Case 167
If GRAPHIC_MODE Then ZX80_To_ASCII = "b" Else ZX80_To_ASCII = "%B"
Case 168
If GRAPHIC_MODE Then ZX80_To_ASCII = "c" Else ZX80_To_ASCII = "%C"
Case 169
If GRAPHIC_MODE Then ZX80_To_ASCII = "d" Else ZX80_To_ASCII = "%D"
Case 170
If GRAPHIC_MODE Then ZX80_To_ASCII = "e" Else ZX80_To_ASCII = "%E"
Case 171
If GRAPHIC_MODE Then ZX80_To_ASCII = "f" Else ZX80_To_ASCII = "%F"
Case 172
If GRAPHIC_MODE Then ZX80_To_ASCII = "g" Else ZX80_To_ASCII = "%G"
Case 173
If GRAPHIC_MODE Then ZX80_To_ASCII = "h" Else ZX80_To_ASCII = "%H"
Case 174
If GRAPHIC_MODE Then ZX80_To_ASCII = "i" Else ZX80_To_ASCII = "%I"
Case 175
If GRAPHIC_MODE Then ZX80_To_ASCII = "j" Else ZX80_To_ASCII = "%J"
Case 176
If GRAPHIC_MODE Then ZX80_To_ASCII = "k" Else ZX80_To_ASCII = "%K"
Case 177
If GRAPHIC_MODE Then ZX80_To_ASCII = "l" Else ZX80_To_ASCII = "%L"
Case 178
If GRAPHIC_MODE Then ZX80_To_ASCII = "m" Else ZX80_To_ASCII = "%M"
Case 179
If GRAPHIC_MODE Then ZX80_To_ASCII = "n" Else ZX80_To_ASCII = "%N"
Case 180
If GRAPHIC_MODE Then ZX80_To_ASCII = "o" Else ZX80_To_ASCII = "%O"
Case 181
If GRAPHIC_MODE Then ZX80_To_ASCII = "p" Else ZX80_To_ASCII = "%P"
Case 182
If GRAPHIC_MODE Then ZX80_To_ASCII = "q" Else ZX80_To_ASCII = "%Q"
Case 183
If GRAPHIC_MODE Then ZX80_To_ASCII = "r" Else ZX80_To_ASCII = "%R"
If Computer = "SPECTRUM" Then ZX80_To_ASCII = "ATN "
Case 184
If GRAPHIC_MODE Then ZX80_To_ASCII = "s" Else ZX80_To_ASCII = "%S"
Case 185
If GRAPHIC_MODE Then ZX80_To_ASCII = "t" Else ZX80_To_ASCII = "%T"
Case 186
If GRAPHIC_MODE Then ZX80_To_ASCII = "u" Else ZX80_To_ASCII = "%U"
Case 187
If GRAPHIC_MODE Then ZX80_To_ASCII = "v" Else ZX80_To_ASCII = "%V"
Case 188
If GRAPHIC_MODE Then ZX80_To_ASCII = "w" Else ZX80_To_ASCII = "%W"
Case 189
If GRAPHIC_MODE Then ZX80_To_ASCII = "x" Else ZX80_To_ASCII = "%X"
Case 190
If GRAPHIC_MODE Then ZX80_To_ASCII = "y" Else ZX80_To_ASCII = "%Y"
Case 191
If GRAPHIC_MODE Then ZX80_To_ASCII = "z" Else ZX80_To_ASCII = "%Z"
Case 192 To 211
ZX80_To_ASCII = "?"

Case 212
ZX80_To_ASCII = Chr(&H22)
Case 213
ZX80_To_ASCII = " THEN "
Case 214
ZX80_To_ASCII = " TO "
Case 215
ZX80_To_ASCII = ";"
Case 216
ZX80_To_ASCII = ","
Case 217
ZX80_To_ASCII = ")"
Case 218
ZX80_To_ASCII = "("
Case 219
ZX80_To_ASCII = " NOT "
Case 220
ZX80_To_ASCII = "-"
Case 221
ZX80_To_ASCII = "+"
Case 222
ZX80_To_ASCII = "*"
Case 223
ZX80_To_ASCII = "/"
Case 224
ZX80_To_ASCII = " AND "
Case 225
ZX80_To_ASCII = " OR "
Case 226
ZX80_To_ASCII = "**"
Case 227
ZX80_To_ASCII = "="
Case 228
ZX80_To_ASCII = ">"
Case 229
ZX80_To_ASCII = "<"
Case 230
ZX80_To_ASCII = "LIST "
Case 231
ZX80_To_ASCII = "RETURN "
Case 232
ZX80_To_ASCII = "CLS "
Case 233
ZX80_To_ASCII = "DIM "
Case 234
ZX80_To_ASCII = "SAVE"
Case 235
ZX80_To_ASCII = "FOR "
Case 236
ZX80_To_ASCII = "GOTO "
Case 237
ZX80_To_ASCII = "POKE "
Case 238
ZX80_To_ASCII = "INPUT "

Case 239
ZX80_To_ASCII = "RANDOMISE "

Case 240
ZX80_To_ASCII = "LET "

Case 241
ZX80_To_ASCII = "?"
Case 242
ZX80_To_ASCII = "?"
Case 243
ZX80_To_ASCII = "NEXT "
Case 244
ZX80_To_ASCII = "PRINT "
Case 245
ZX80_To_ASCII = "?"
Case 246
ZX80_To_ASCII = "NEW "
Case 247
ZX80_To_ASCII = "RUN "
Case 248
ZX80_To_ASCII = "STOP "
Case 249
ZX80_To_ASCII = "CONTINUE "
Case 250
ZX80_To_ASCII = "IF "
Case 251
ZX80_To_ASCII = "GO SUB"
Case 252
ZX80_To_ASCII = "LOAD "
Case 253
ZX80_To_ASCII = "CLEAR "
Case 254
ZX80_To_ASCII = "REM "
Case 255
ZX80_To_ASCII = "?"
End Select

End Function

Sub Load_OFile(Filename As String)

Dim m_iLen, m_iFile, OHeader As O_header

m_iFile = FreeFile
      
     Open Filename For Binary Access Read Lock Write As #m_iFile
         m_iLen = LOF(m_iFile)
        Get #m_iFile, 1, OHeader
        Dim len_bas
         len_bas = OHeader.SYS_EOF - 16424
       'On Error GoTo err1
         ReDim Prog_ZX(0 To len_bas - 1) As Byte
         Get #m_iFile, 41, Prog_ZX()
err1:
     Close #m_iFile
     
Computer = "ZX80" ' or ="SPECTRUM"
Call Conversion_ZX80(len_bas, 0)
        
Disp_Err 20
End Sub
Function Get_Rem80(Text As String) As String
Dim TmpChar As String * 1, ByteCnt

Get_Rem80 = " REM [HEX:\" & vbCrLf

ByteCnt = 0
Do While Text <> ""
TmpChar = Text
Text = Right(Text, Len(Text) - 1)
Get_Rem80 = Get_Rem80 & Hex8(Asc(TmpChar)) & ","
ByteCnt = ByteCnt + 1
If ByteCnt = 8 Then ByteCnt = 0: Get_Rem80 = Get_Rem80 & "\" & vbCrLf
Loop
If Right(Get_Rem80, 2) = "\" & vbCrLf Then Get_Rem80 = Left(Get_Rem80, Len(Get_Rem80) - 2)
If Right(Get_Rem80, 1) = "," Then Get_Rem80 = Left(Get_Rem80, Len(Get_Rem80) - 1)
Get_Rem80 = Get_Rem80 & " ]" & vbCrLf
End Function

Function Get_InfoREM80(AtAdd As Long, ToADD As Long) As String
Dim AddCnt
Dim ATaddTmp
ATaddTmp = AtAdd
Get_InfoREM80 = vbCrLf
Get_InfoREM80 = Get_InfoREM80 & "# REM "
AddCnt = 0
Do While Prog_ZX(ATaddTmp) <> &H76 And AddCnt < 63
Get_InfoREM80 = Get_InfoREM80 & ZX80_To_ASCII(Prog_ZX(ATaddTmp))
ATaddTmp = ATaddTmp + 1: AddCnt = AddCnt + 1
If AddCnt = 32 Then Get_InfoREM80 = Get_InfoREM80 & vbCrLf & "#     "
Loop
'Get_InfoREM80 = Get_InfoREM80 & vbCrLf
End Function
